#===============================================================================
# &rodionova.2001year.                .
#===============================================================================

set mom_output_file_suffix                 "up"

#_______________________________________________________________________________
# The following procedures are executed to get the commentary data output and the
# warning output. The commentary output data is stored in the the file ptp_name.lpt.
# The warning data is stored in the file ptp_name_warning.out.
#_______________________________________________________________________________
proc  OPEN_files {} {
  global mom_logname mom_date mom_ug_version mom_part_name mom_event_handler_file_name mom_definition_file_name
  global mom_output_file_directory mom_output_file_basename mom_output_file_suffix
  global mom_sys_output_file_suffix mom_sys_list_file_suffix output_extn list_extn
  global mom_parent_group_name mom_sys_group_output
  global ptp_file_name lpt_file_name warning_file_name mom_group_name prev_group_name
  global list_file warn_file group_list_file group_warn_file group_level
  global group_output_file group_lpt_file_name group_warning_file_name
  global warn_count line_count page_number
  global group_warn_count group_line_count group_page_number
  global mom_sys_ptp_output mom_sys_list_output mom_sys_warning_output mom_warning_info
  global isinit_files isinit_group
  global mom_tool_use ; # Temporary fix for mom_tool_count bug

#======================================================

  if {[llength [info commands InitInstance] ]} {
    InitInstance
  }

#======================================================

  if {![hiset isinit_files]} {
    for {set i 0} {$i <= 100} {incr i} { set mom_tool_use($i,0) 0 }

    SEQNO_RESET ; #<4133654>

    set output_extn "" ; set list_extn ""

    if {[hiset mom_output_file_suffix]} {
      if {[string length $mom_output_file_suffix] > 0} {
        set output_extn ".${mom_output_file_suffix}"
      }
    }

    set pre_ptp_name "${mom_output_file_directory}${mom_output_file_basename}${output_extn}"

    if {[string length $output_extn] == 0} {
      if {[string length $mom_sys_output_file_suffix] > 0} {
        set output_extn ".${mom_sys_output_file_suffix}"
      }
    }

    if {[string length $mom_sys_list_file_suffix] > 0} {
      set list_extn ".${mom_sys_list_file_suffix}"
    }

    set ptp_file_name "${mom_output_file_directory}${mom_output_file_basename}${output_extn}"
    set lpt_file_name "${mom_output_file_directory}${mom_output_file_basename}${list_extn}"
    set warning_file_name "${mom_output_file_directory}${mom_output_file_basename}_warning.out"

    # puts stdout  "******************************************************"
    # puts stdout  "  UG_POST    VERSION       : $mom_ug_version"
    # puts stdout  "******************************************************"
    # puts stdout  "  USER NAME / DATE   : $mom_logname / $mom_date"
    # puts stdout  "  INPUT PART        : $mom_part_name"
    # puts stdout  "  USING             : $mom_event_handler_file_name , $mom_definition_file_name"
    # puts stdout  "******************************************************"

    MOM_close_output_file $pre_ptp_name
    if {"$ptp_file_name" != "$pre_ptp_name"} {MOM_close_output_file $ptp_file_name}
    # puts stdout  "  CLOSED PRE-EXISTING MAIN $ptp_file_name"
    if {[file exists $pre_ptp_name]} {
      MOM_remove_file $pre_ptp_name
      # puts stdout  "  REMOVED PRE-EXISTING MAIN $pre_ptp_name"
    }
    if {[file exists $ptp_file_name]} {
      MOM_remove_file $ptp_file_name
      # puts stdout  "  REMOVED PRE-EXISTING MAIN $ptp_file_name"
    }

    if {$mom_sys_ptp_output == "ON"} {
#===================================== Rodionova
      if {[file exists $ptp_file_name]} {

        if {[llength [info commands MOM_remove_file_ex ] ]} {
          set err [ MOM_remove_file_ex $ptp_file_name ]
          # puts stdout  " MOM_remove_file_ex=$err "
        } else {

          set err ""
          catch { file delete -force -- $ptp_file_name } err ;
          # puts stdout  "  err=$err "
          set mom_warning_info $err

        }

        if {"$err"!="0" || $err!=""} {
          set mom_warning_info "\n\n Error: error deleting\n\n'$ptp_file_name'\n\n : permission denied!\n\n-  - ????\n     Vericut!." ;
          MOM_output_to_listing_device $mom_warning_info
          ;# MOM_abort $mom_warning_info
          if {[llength [info commands MOM_ui_message ] ]} {
            MOM_ui_message ERROR OK $mom_warning_info
          }
        }

      }

      set err ""
      catch { MOM_open_output_file $ptp_file_name  } err ;
      if {$err!=""} { MOM_abort "\n\n\t     !\n\n" ; }
      # puts stdout  "  OPENED FRESH MAIN $ptp_file_name"
      # puts stdout  "  GENERATING        : $ptp_file_name"
#=====================================##end
    }

    if {$mom_sys_list_output == "ON"} {
      if {[file exists $lpt_file_name]} {
        MOM_remove_file $lpt_file_name
        # puts stdout  "  REMOVED PRE-EXISTING MAIN $lpt_file_name"
      }
      set list_file [open "$lpt_file_name" w ] ; set line_count 0 ; set page_number 0
      # puts stdout  "  OPENED FRESH MAIN $lpt_file_name ; CHANNEL $list_file"
      # puts stdout  "  GENERATING        : $lpt_file_name"
    }

    if {$mom_sys_warning_output == "ON"} {
      if {[file exists $warning_file_name]} {
        MOM_remove_file $warning_file_name
        # puts stdout  "  REMOVED PRE-EXISTING MAIN $warning_file_name"
      }
      set warn_file [open "$warning_file_name" w ] ; set warn_count 0
      # puts stdout  "  OPENED FRESH MAIN $warning_file_name ; CHANNEL $warn_file"
      # puts stdout  "  GENERATING        : $warning_file_name"
    }

    set isinit_files TRUE
  }

  if {$mom_sys_group_output == "ON"} {
    if {[hiset mom_group_name] && [hiset group_level]} {
      if {[hiset prev_group_name]} {
        if {$mom_group_name == "$prev_group_name"} {
          return
        } else {
          if {[hiset group_output_file($prev_group_name)]} {
            MOM_close_output_file $group_output_file($prev_group_name)
            # puts stdout  "  CLOSED PREVIOUS GROUP $group_output_file($prev_group_name)"
          }
          if {[hiset group_list_file]} {
            # puts stdout  "  CLOSED PREVIOUS GROUP LIST CHANNEL $group_list_file"
            close $group_list_file ; unset group_list_file
          }
          if {[hiset group_warn_file]} {
            # puts stdout  "  CLOSED PREVIOUS GROUP WARN CHANNEL $group_warn_file"
            close $group_warn_file ; unset group_warn_file
          }
        }
      }
      set prev_group_name $mom_group_name

      if {![hiset isinit_group($mom_group_name)] && $group_level == 1} {
        set group_name_lowercase [string tolower $mom_group_name]

        if {$mom_sys_ptp_output == "ON"} {
          set grp_ptp_name "${mom_output_file_basename}_${group_name_lowercase}${output_extn}"
          if { [string length $grp_ptp_name] > 30} {
            set grp_ptp_name "${group_name_lowercase}${output_extn}"
            set mom_warning_info "Group name too long. Creating $grp_ptp_name"
            MOM_catch_warning
          }
          set group_output_file($mom_group_name) "${mom_output_file_directory}${grp_ptp_name}"
          MOM_close_output_file $group_output_file($mom_group_name)
          # puts stdout  "  CLOSED PRE-EXISTING GROUP $group_output_file($mom_group_name)"
          if {[file exists $group_output_file($mom_group_name)]} {
            MOM_remove_file $group_output_file($mom_group_name)
            # puts stdout  "  REMOVED PRE-EXISTING GROUP $group_output_file($mom_group_name)"
          }
          MOM_open_output_file $group_output_file($mom_group_name)
          # puts stdout  "  OPENED FRESH GROUP $group_output_file($mom_group_name)"
          # puts stdout  "  GENERATING GROUP FILE  : $group_output_file($mom_group_name)"
          # MOM_output_literal "(*** generating group file $group_output_file($mom_group_name) ***)"
        }

        if {$mom_sys_list_output == "ON"} {
          set grp_lpt_name ${mom_output_file_basename}_${group_name_lowercase}${list_extn}
          if { [string length $grp_lpt_name] > 30} {
            set grp_lpt_name ${group_name_lowercase}${list_extn}
            set mom_warning_info "Group name too long. Creating $grp_lpt_name"
            MOM_catch_warning
          }
          set group_lpt_file_name "${mom_output_file_directory}${grp_lpt_name}"
          if {[hiset group_list_file]} {
            # puts stdout  "  CLOSED PRE-EXISTING GROUP LIST CHANNEL $group_list_file"
            close $group_list_file ; unset group_list_file
          }
          if {[file exists $group_lpt_file_name]} {
            MOM_remove_file $group_lpt_file_name
            # puts stdout  "  REMOVED PRE-EXISTING GROUP LIST $group_lpt_file_name"
          }
          set group_list_file [open "$group_lpt_file_name" w] ; set group_line_count 0 ; set group_page_number 0
          # puts stdout  "  OPENED FRESH GROUP LIST $group_lpt_file_name ; CHANNEL $group_list_file"
          # puts stdout  "  GENERATING GROUP FILE  : $group_lpt_file_name"
        }

        if {$mom_sys_warning_output == "ON"} {
          set grp_warn_name ${mom_output_file_basename}_${group_name_lowercase}_warning.out
          if {[string length $grp_warn_name] > 30} {
            set grp_warn_name ${group_name_lowercase}_warning.out
            if {[string length $grp_warn_name] > 30} { set grp_warn_name ${group_name_lowercase}.out }
            set mom_warning_info "Group name too long. Creating $grp_warn_name"
            MOM_catch_warning
          }
          set group_warning_file_name ${mom_output_file_directory}${grp_warn_name}
          if {[hiset group_warn_file]} {
            # puts stdout  "  CLOSED PRE-EXISTING GROUP WARN CHANNEL $group_warn_file"
            close $group_warn_file ; unset group_warn_file
          }
          if {[file exists $group_warning_file_name]} {
            MOM_remove_file $group_warning_file_name
            # puts stdout  "  REMOVED PRE-EXISTING GROUP WARN $group_warning_file_name"
          }
          set group_warn_file [open "$group_warning_file_name" w] ; set group_warn_count 0
          # puts stdout  "  OPENED FRESH GROUP WARN $group_warning_file_name ; CHANNEL $group_warn_file"
          # puts stdout  "  GENERATING GROUP FILE  : $group_warning_file_name"
        }

        set isinit_group($mom_group_name) TRUE
      }
    }
  }

}


proc  CLOSE_files {} {
         global warn_file list_file
         global group_warn_file group_list_file
         global warning_file_name
         global warn_count

#===================================== Rodionova
         if {[hiset list_file]} {close $list_file ; unset list_file}
         if {[hiset warn_file]} {close $warn_file ; unset warn_file}
#=====================================##end

         if {[hiset group_list_file] == 0 && [hiset group_warn_file] == 0} {
           if {[hiset list_file]} {close $list_file ; unset list_file}
           if {[hiset warn_file]} {close $warn_file ; unset warn_file}
           if { $warn_count > 0 } {
              MOM_output_to_listing_device\
                  "***********************************************************"
              MOM_output_to_listing_device\
                  "Check $warning_file_name for any Errors/Warnings during postprocessing"
              MOM_output_to_listing_device\
                  "***********************************************************"
           } \
           else {
#===================================== Rodionova
               if {[file exists $warning_file_name]} {
                     catch { MOM_remove_file $warning_file_name }
               }
           }
#=====================================##end
         } else {
           if {[hiset group_list_file]} {close $group_list_file ; unset group_list_file}
           if {[hiset group_warn_file]} {close $group_warn_file ; unset group_warn_file}
         }

    if {[llength [info commands _set_attribute] ]} {
      _set_attribute
    }

    global opu_file_num_sum ; #    
    if {[info exists opu_file_num_sum]} {set opu_file_num_sum 0}
    #catch { unset opu_file_num_sum ; }

    global opu_file_sym_sum ; #      
    if {[info exists opu_file_sym_sum]} {set opu_file_sym_sum 0}
    #catch { unset opu_file_sym_sum ; }

}


proc LIST_FILE { } {

     global mom_o_buffer
         global space_buffer
         global list_file group_list_file
         global mom_sys_list_file_columns
         global mom_sys_list_file_rows
         global warn_count
         global group_warn_count
         global mom_sys_list_output mom_sys_commentary_output
         global tape_bytes
         global shop_docs_block
         global mom_sys_control_in mom_sys_filler
         global sys_axis mom_pos com_feed_rate mom_spindle_speed mom_kin_output_unit
         global commentary_out

         incr tape_bytes [string length $mom_o_buffer]

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         global opu_file_num_sum ; #    
         if {![info exists opu_file_num_sum]} {set opu_file_num_sum 0}
         global opu_file_sym_sum ; #      
         if {![info exists opu_file_sym_sum]} {set opu_file_sym_sum 0}
         set lstr [ string length $mom_o_buffer ]
         if {$lstr!=0} {

           global tcl_platform
           if [string match "*windows*" $tcl_platform(platform)] {
              incr lstr 2 ; # + "\r\n"
            } else {
              incr lstr 1 ; # + "\n" || "\r"
           }

           incr opu_file_sym_sum $lstr
           incr opu_file_num_sum

         }
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

         if {$mom_sys_list_output != "ON"} { return }

         set commentary ""

         if {![info exists mom_kin_output_unit]} {set mom_kin_output_unit "IN"}
         if {[string last $mom_sys_control_in $mom_o_buffer] < 0 && ![info exists shop_docs_block]} {
           if {$mom_kin_output_unit == "IN"} {
             if {$commentary_out(x) > 0} {set commentary [format "%10.4f" $mom_pos(0)]}
             if {$commentary_out(y) > 0} {append commentary [format "%10.4f" $mom_pos(1)]}
             if {$commentary_out(z) > 0} {append commentary [format "%10.4f" $mom_pos(2)]}
             if {$commentary_out(4axis) > 0} {append commentary [format "%8.3f" $mom_pos(3)]}
             if {$commentary_out(5axis) > 0} {append commentary [format "%8.3f" $mom_pos(4)]}
             if {$commentary_out(feed) > 0} {append commentary [format "%7.1f" $com_feed_rate]}
             if {$commentary_out(speed) > 0} {append commentary [format "%5.0f" $mom_spindle_speed]}
           } else {
             if {$commentary_out(x) > 0} {set commentary [format "%10.3f" $mom_pos(0)]}
             if {$commentary_out(y) > 0} {append commentary [format "%10.3f" $mom_pos(1)]}
             if {$commentary_out(z) > 0} {append commentary [format "%10.3f" $mom_pos(2)]}
             if {$commentary_out(4axis) > 0} {append commentary [format "%8.3f" $mom_pos(3)]}
             if {$commentary_out(5axis) > 0} {append commentary [format "%8.3f" $mom_pos(4)]}
             if {$commentary_out(feed) > 0} {append commentary [format "%7.0f" $com_feed_rate]}
             if {$commentary_out(speed) > 0} {append commentary [format "%5.0f" $mom_spindle_speed]}
           }

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
           global mom_machine_time
           global mom_event_time
           if {[hiset mom_machine_time] == 0} {set mom_machine_time 0}
           if {[hiset mom_event_time] == 0} {set mom_event_time 0}
           if {$commentary_out(time1) > 0} {append commentary [format "   %.3f " $mom_event_time]}
           if {$commentary_out(time2) > 0} {append commentary [format "  (%.2f) " $mom_machine_time]}
           if {$commentary_out(size) > 0} {append commentary [format "   ( %.0f )" $opu_file_sym_sum ]}
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

           set local_o_buffer $mom_o_buffer
           set outs [concat $local_o_buffer " "]
           set outs_length [string length $outs]
           set commentary_length [string length $commentary]
           if {[expr $outs_length + $commentary_length] < $mom_sys_list_file_columns} {
                  set filler [format "%*s" [expr $mom_sys_list_file_columns - $outs_length - [string length $commentary]] " "]
                  append outs "$filler$commentary"
           } else {
                  set filler [format "%*s" [expr $mom_sys_list_file_columns - [string length $commentary]] " "]
                  append outs "\n$filler$commentary"
           }
         } else {
           set outs $mom_o_buffer
         }

         if {[hiset list_file]} {puts $list_file $outs}
         if {[hiset group_list_file]} {puts $group_list_file $outs}

}

proc  LIST_FILE_HEADER {} {
  global mom_sys_list_output mom_sys_header_output mom_sys_list_file_columns
  global mom_ug_version mom_logname mom_date
  global mom_part_name mom_event_handler_file_name mom_definition_file_name
  global ptp_file_name lpt_file_name warning_file_name
  global group_output_file group_lpt_file_name group_warning_file_name mom_group_name
  global list_file group_list_file mom_sys_filler_length
  global warn_count mom_sys_leader mom_sys_filler
  global group_warn_count global header
  global isdone_list_file prev_group_lpt_file_name
  global mom_kin_machine_type
  global mom_sys_commentary_list commentary_out

  set warn_count 0
  set group_warn_count 0
  set blan      " "

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#  set mom_sys_list_file_columns 100
  if {![info exist mom_sys_list_file_columns]} {set mom_sys_list_file_columns 100 ; }
  if {$mom_sys_list_file_columns<=133} {
  	set mom_sys_list_file_columns 150
  }
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  if {![info exist mom_kin_machine_type]} {set mom_kin_machine_type "3_axis_mill"}
  switch $mom_kin_machine_type {
      lathe             {set sys_axis 2}
      3_AXIS_MILL -
      3_axis_mill       {set sys_axis 3}
      4_axis_head -
      4_AXIS_HEAD -
      4_axis_table -
      4_AXIS_TABLE -
      mill_turn -
      MILL_TURN         {set sys_axis 4}
      5_axis_dual_table -
      5_AXIS_DUAL_TABLE -
      5_axis_dual_head -
      5_AXIS_DUAL_HEAD -
      5_axis_head_table -
      5_AXIS_HEAD_TABLE {set sys_axis 5}
      default           {set sys_axis 3}
   }

   if {![info exist mom_sys_commentary_list]} {set mom_sys_commentary_list "x y z 4axis 5axis feed speed"}

   if {[string match "x " $mom_sys_commentary_list] >= 0} {
     set commentary_out(x) "1"
   } else {
     set commentary_out(x) "0"
   }

   if {[string match "y " $mom_sys_commentary_list] >= 0 && $sys_axis != 2} {
     set commentary_out(y) "1"
   } else {
     set commentary_out(y) "0"
   }

   if {[string match "z " $mom_sys_commentary_list] >= 0} {
     set commentary_out(z) "1"
   } else {
     set commentary_out(z) "0"
   }

   if {[string match "4axis" $mom_sys_commentary_list] >= 0 && $sys_axis >= 4} {
     set commentary_out(4axis) "1"
   } else {
     set commentary_out(4axis) "0"
   }

   if {[string match "5axis" $mom_sys_commentary_list] >= 0 && $sys_axis == 5} {
     set commentary_out(5axis) "1"
   } else {
     set commentary_out(5axis) "0"
   }

   if {[string match "feed" $mom_sys_commentary_list] >= 0} {
     set commentary_out(feed) "1"
   } else {
     set commentary_out(feed) "0"
   }

   if {[string match "speed" $mom_sys_commentary_list] >= 0} {
     set commentary_out(speed) "1"
   } else {
     set commentary_out(speed) "0"
   }

   set commentary_header ""

   if {$commentary_out(x) > 0} {set commentary_header "  ABS-X  "}
   if {$commentary_out(y) > 0} {append commentary_header "   ABS-Y  "}
   if {$commentary_out(z) > 0} {append commentary_header "   ABS-Z  "}
   if {$commentary_out(4axis) > 0} {append commentary_header " ABS-$mom_sys_leader(fourth_axis)  "}
   if {$commentary_out(5axis) > 0} {append commentary_header " ABS-$mom_sys_leader(fifth_axis)  "}
   if {$commentary_out(feed) > 0} {append commentary_header " FEED"}
   if {$commentary_out(speed) > 0} {append commentary_header "  RPM"}

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   set commentary_out(time1) "1"
   set commentary_out(time2) "1"
   set commentary_out(size)  "1"
   if {$commentary_out(time1) > 0} {append commentary_header "  eventT(')  "}
   if {$commentary_out(time2) > 0} {append commentary_header "  T(') "}
   if {$commentary_out(size) > 0} {append commentary_header "  Size "}
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   set commentary_header_length [string length $commentary_header]
   set mom_sys_filler_length [expr $mom_sys_list_file_columns-$commentary_header_length]
   set mom_sys_filler [format "%*s" $mom_sys_filler_length " "]

   if {$mom_sys_header_output != "ON" || $mom_sys_list_output != "ON"} { return }

   if {[hiset list_file] && ![hiset isdone_list_file]} {
#    puts $list_file  "\n\n\n\n\n\n\n"
#    puts $list_file  "\t\tUU     UU    GGGGG        PPPPPP     OOOOO      SSSSS   TTTTTTTT"
#    puts $list_file  "\t\tUU     UU   GGGGGGG      PPPPPPPP   OOOOOOO    SSSSSSS  TTTTTTTT"
#    puts $list_file  "\t\tUU     UU  GG     GG     PP    PP  OO     OO  SS           TT   "
#    puts $list_file  "\t\tUU     UU  GG            PP    PP  OO     OO  SS           TT   "
#    puts $list_file  "\t\tUU     UU  GG   GGGG     PPPPPPP   OO     OO    SSSSSS     TT   "
#    puts $list_file  "\t\tUU     UU  GG     GG     PPPPPP    OO     OO         SS    TT   "
#    puts $list_file  "\t\tUU     UU  GG     GG     PP        OO     OO  SS     SS    TT   "
#    puts $list_file  "\t\t UUUUUUU    GGGGGGG      PP         OOOOOOO   SSSSSSSS     TT   "
#    puts $list_file  "\t\t  UUUUU      GGGGG       PP          OOOOO     SSSSSS      TT   "
#
#    puts $list_file  "\n\n\n\n\n\n\n"

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    puts $list_file  "\n\t LIST FILE \n\n"
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    puts $list_file  "                VERSION       NUMBER : $mom_ug_version"
    puts $list_file  "                EXECUTED      BY     : $mom_logname"
    puts $list_file  "                EXECUTION     DATE   : $mom_date"
    puts $list_file  "                POST          NAME   : "
    puts $list_file  "                TCL     FILE  NAME   : $mom_event_handler_file_name"
    puts $list_file  "                DEF     FILE  NAME   : $mom_definition_file_name"
    puts $list_file  "                PART    FILE  NAME   : $mom_part_name"
    if {[hiset ptp_file_name]} {puts $list_file  "                PTP     FILE  NAME   : $ptp_file_name"}
    if {[hiset lpt_file_name]} {puts $list_file  "                LPT     FILE  NAME   : $lpt_file_name"}
    if {[hiset warning_file_name]} {puts $list_file  "                WARNING FILE  NAME   : $warning_file_name"}
    puts $list_file  "\n"
    puts $list_file $mom_sys_filler$commentary_header
    set isdone_list_file TRUE
  }

  if {![hiset group_lpt_file_name]} {return}
  if {[hiset prev_group_lpt_file_name]} {
    if {$group_lpt_file_name == "$prev_group_lpt_file_name"} {
      return
    } else {
      set prev_group_lpt_file_name $group_lpt_file_name
    }
  } else {
    set prev_group_lpt_file_name $group_lpt_file_name
  }

  if {[hiset group_list_file]} {
    puts $group_list_file  "\n\n\n\n\n\n\n"

    puts $group_list_file  "\t\tUU     UU    GGGGG        PPPPPP     OOOOO      SSSSS   TTTTTTTT"
    puts $group_list_file  "\t\tUU     UU   GGGGGGG      PPPPPPPP   OOOOOOO    SSSSSSS  TTTTTTTT"
    puts $group_list_file  "\t\tUU     UU  GG     GG     PP    PP  OO     OO  SS           TT   "
    puts $group_list_file  "\t\tUU     UU  GG            PP    PP  OO     OO  SS           TT   "
    puts $group_list_file  "\t\tUU     UU  GG   GGGG     PPPPPPP   OO     OO    SSSSSS     TT   "
    puts $group_list_file  "\t\tUU     UU  GG     GG     PPPPPP    OO     OO         SS    TT   "
    puts $group_list_file  "\t\tUU     UU  GG     GG     PP        OO     OO  SS     SS    TT   "
    puts $group_list_file  "\t\t UUUUUUU    GGGGGGG      PP         OOOOOOO   SSSSSSSS     TT   "
    puts $group_list_file  "\t\t  UUUUU      GGGGG       PP          OOOOO     SSSSSS      TT   "

    puts $group_list_file  "\n\n\n\n\n\n\n"

    puts $group_list_file  "     VERSION NUMBER :       $mom_ug_version"
    puts $group_list_file  "     EXECUTED BY :          $mom_logname"
    puts $group_list_file  "     EXECUTION DATE :       $mom_date"
    puts $group_list_file  "     POST NAME : "
    puts $group_list_file  "     TCL FILE NAME :        $mom_event_handler_file_name"
    puts $group_list_file  "     DEF FILE NAME :        $mom_definition_file_name"
    puts $group_list_file  "     PART FILE NAME :       $mom_part_name"
    if {[hiset group_output_file($mom_group_name)]} {
      puts $group_list_file  "   PTP FILE NAME :        $group_output_file($mom_group_name)"
    }
    puts $group_list_file  "     LPT FILE NAME :        $group_lpt_file_name"
    if {[hiset group_warning_file_name]} {puts $group_list_file  "     WARNING FILE NAME :    $group_warning_file_name"}
    puts $group_list_file  "\n"
    puts $list_file $mom_sys_filler$commentary_header
  }
}

proc  LIST_FILE_TRAILER {} {
         global list_file warn_count page_number
         global group_list_file group_warn_count group_page_number
         global mom_machine_time
         global mom_tool_use
         global mom_tool_count
         global tape_bytes mom_output_unit

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#    if {[llength [info commands PB_CMD_time_cnc_end_of_program] ]} { PB_CMD_time_cnc_end_of_program }
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

         if {[hiset mom_machine_time] == 0} {set mom_machine_time 0}
         if {[hiset list_file] && [hiset group_list_file] == 0} {
           puts $list_file  "\f"
           puts $list_file  "     \n\n\n\n\n\n\n                    "
           puts $list_file  "     UG_POST MACHINE TIME            :[ format  "%.2f" $mom_machine_time]"
           if {$mom_output_unit == "IN"} {
             set tape_feet [expr $tape_bytes / 120.0]
             puts $list_file  "     UG_POST TAPE FEET               :[ format  "%.2f" $tape_feet]"
           } else {
             set tape_meters [expr $tape_bytes * 25.4 / 10000.0]
             puts $list_file  "     UG_POST TAPE METERS             :[ format  "%.2f" $tape_meters]"
           }
           puts $list_file  "     NUMBER OF WARNINGS              : $warn_count"
           if {[isset mom_tool_count] == "n"} {return}
           puts $list_file  "\f "
           puts $list_file  "********************************************************************************"
           puts $list_file  "                       TOOL LIST WITH TOOL USED TIME"
           puts $list_file  "********************************************************************************"

           if {[hiset mom_tool_count]} {
             for { set nn 0 } { $nn < $mom_tool_count } {incr nn} {
               if {[hiset mom_tool_use($nn,0)] && [hiset mom_tool_use($nn,1)]} {
                 set a [scan $mom_tool_use($nn,0) %d tn]
                 puts $list_file  "  TOOL  NUMBER [ format  "%s  %.2f"    $tn         $mom_tool_use($nn,1)] minutes"
               }
             }
           }
           puts $list_file  "********************************************************************************"
         }
         if {[hiset group_list_file]} {
           puts $group_list_file  "\f"
           puts $group_list_file  "     \n\n\n\n\n\n\n                    "
           puts $group_list_file  "     UG_POST MACHINE TIME            :[ format  "%.2f" $mom_machine_time]"
           puts $group_list_file  "     NUMBER OF WARNINGS              : $warn_count"
           if {[isset mom_tool_count] == "n"} {return}
           puts $group_list_file  "\f "
           puts $group_list_file  "********************************************************************************"
           puts $group_list_file  "                       TOOL LIST WITH TOOL USED TIME"
           puts $group_list_file  "********************************************************************************"

           if {[hiset mom_tool_count]} {
             for { set nn 0 } { $nn < $mom_tool_count } {incr nn} {
               if {[hiset mom_tool_use($nn,0)] && [hiset mom_tool_use($nn,1)]} {
                 set a [scan $mom_tool_use($nn,0) %d tn]
                 puts $list_file  "  TOOL  NUMBER [ format  "%s  %.2f"    $tn         $mom_tool_use($nn,1)] minutes"
               }
             }
           }
           puts $group_list_file  "********************************************************************************"
         }
}


#
#
#
proc  MOM_gouge_marker {} {
#_______________________________________________________________________________
#
# If there is a gouge detected, MOM will issue this event
# a flag handles the action
#
#_______________________________________________________________________________
  global mom_path_name
  global mom_warning_info
  global mom_path_warning

  set mom_warning_info "It is detected gouge ..."

  MOM_output_to_listing_device $mom_warning_info  ;
  MOM_catch_warning ;
  MOM_path_warning
}


#
#==================================================================
proc MOM_path_warning { } {
#==================================================================
# This procedure is executed when the path warning (has Inconsistent axis, e.t.)
  global mom_seqnum mom_warning_info
  global mom_path_warning
  if {[info exists mom_path_warning]==0} { return 0 ; }
  if {[string length $mom_path_warning]<=0} { return 0 ; }

  set seqN 0.0
  if {[info exists mom_seqnum]} { set seqN [ expr double($mom_seqnum) ] }
  set seqN [ format "%.0f" $seqN ]
  set mom_warning_info "WARNING:(N${seqN}) $mom_path_warning"
  MOM_output_to_listing_device $mom_warning_info  ;
  MOM_catch_warning ;

}

#
# 
#=============================================================
proc MOM_lintol { } {
#=============================================================
  global mom_kin_linearization_flag
  global mom_kin_linearization_tol
  global mom_lintol_status
  global mom_lintol

  if {$mom_lintol_status == "ON"} {
     set mom_kin_linearization_flag "TRUE"
     if [info exists mom_lintol] {set mom_kin_linearization_tol $mom_lintol}
  } elseif {$mom_lintol_status == "OFF"} {
     set mom_kin_linearization_flag "FALSE"
  }

  if {[info exists mom_kin_linearization_flag]} {
      set TOL [ format "%.4f" $mom_kin_linearization_tol ]
      set mom_warning_info "\tMOM_lintol->:   - $mom_kin_linearization_flag (TOL=$TOL) \n"
      MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;
  }

  MOM_reload_kinematics

}


#
#==================================================================
#proc MOM_on_error { } {
#==================================================================
# This procedure is executed when error.
#
#}

#
#<4133654> mom_seqnum exceeds MAX ? calls MOM_sequence_overflow(if exists), else mom_seqnum is reset.
#proc MOM_sequence_overflow {} { }
#

#=============================================================
proc  MOM_sequence_number {} {
#=============================================================
# This procedure is executed for the Sequence Number command.
#=============================================================
   SEQNO_SET
}


#===================================================
proc  PB_CMD_circular_move_check { } {
#===================================================
# This procedure is executed for each circular move.
# It gets radius start point, end point and center
# the circle data are right.
#===================================================
 global mom_pos_arc_center mom_arc_radius
 global mom_pos mom_prev_pos
 global mom_motion_distance
 global mom_warning_info
 global mom_seqnum

 global mom_operation_type
 if {![info exists mom_operation_type]} { return ; }

 #        Cavity
 if {$mom_operation_type!=260 && ![string match "*Cavity Milling*" $mom_operation_type]} { return ; }

 set ln1 0.0 ;  set ln2 0.0 ;
 for { set ii 0 } {$ii<3} { incr ii } {
    set tmp1 [ expr ( $mom_pos($ii) - $mom_pos_arc_center($ii) ) ]
    set tmp2 [ expr ( $mom_prev_pos($ii) - $mom_pos_arc_center($ii) ) ]
    set ln1 [ expr ( $ln1 + $tmp1 * $tmp1 ) ] ;
    set ln2 [ expr ( $ln2 + $tmp2 * $tmp2 ) ] ;
 }
 set ln1 [ expr sqrt($ln1) ]
 set ln1 [ format "%.4f" $ln1 ]
 set ln2 [ expr sqrt($ln2) ]
 set ln2 [ format "%.4f" $ln2 ]

 if { [expr abs($ln1 - $ln2)] > 0.01  } {
  set r1 [ format "%.4f" $mom_arc_radius ]
  #set mom_warning_info "WARNING: Invalid circle...(r1=$ln1,r2=$ln2 : R=$r1)\n\t\t   Vericut"
  set mom_warning_info "WARNING:    = (r1=$ln1,r2=$ln2 : R=$r1)\n\t\t   Vericut"
  MOM_output_to_listing_device "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
  #MOM_output_to_listing_device $mom_warning_info
  MOM_catch_warning
 }

}


#=============================================================
proc CIRCLE_SET { } {
#=============================================================
  global mom_pos_arc_plane
  switch $mom_pos_arc_plane {
    XY { MOM_suppress once Z K }
    YZ { MOM_suppress once X I }
    ZX { MOM_suppress once Y J }
  }

 if {[llength [info commands PB_CMD_circular_move_check] ]!=0} {
       PB_CMD_circular_move_check
 }

}


############################################################
#
# 
#=============================================================
proc CATCH_WARNING { msg } {
#=============================================================
  global mom_warning_info
  global mom_motion_event
  global mom_event_number

   set level [info level]
   set call_stack ""
   for {set i 1} {$i < $level} {incr i} {
      set call_stack "$call_stack\[ [lindex [info level $i] 0] \]"
   }
   set mom_warning_info "$msg ($mom_motion_event $mom_event_number) " ; # $call_stack
   MOM_output_to_listing_device $mom_warning_info
   MOM_catch_warning
}

#
# 
#=============================================================
proc PB_catch_warning { } {
#=============================================================
  global mom_motion_event
  global mom_event_number
  global mom_operation_name

  global mom_sys_rotary_error mom_warning_info

  if {$mom_warning_info == "ROTARY CROSSING LIMIT."} {
      set mom_sys_rotary_error $mom_warning_info
  }
  if {$mom_warning_info == "secondary rotary position being used"} {
      set mom_sys_rotary_error $mom_warning_info
  }

  global mom_seqnum
  set nk 0 ;
  if {[info exists mom_seqnum]} { set nk [ format "%.0f" $mom_seqnum ] ; }
  set mom_warning_info " =N$nk - $mom_warning_info $mom_motion_event $mom_event_number $mom_operation_name"
  MOM_output_to_listing_device $mom_warning_info
  #MOM_catch_warning

}

#
# 
#=============================================================
proc CHECK_PLANE {} {
#=============================================================
  global mom_tool_axis
  global mom_path_name

  global prev_error_path

#-------- Decision on plane of operation

  if {[EQ_is_equal abs($mom_tool_axis(1)) 1.0]} {
      set g_plane 18
  } elseif {[EQ_is_equal abs($mom_tool_axis(2)) 0.0]} {
      set g_plane 19
  } elseif {[EQ_is_equal abs($mom_tool_axis(2)) 1.0]} {
      set g_plane 17
  } elseif {([EQ_is_gt abs($mom_tool_axis(2)) 0.0] && \
                 [EQ_is_lt abs($mom_tool_axis(2)) 1.0]) || \
             [EQ_is_lt abs($mom_tool_axis(2)) 0.0] } {
      set g_plane "NONE"

      set i [format "%-.7f" $mom_tool_axis(0)]
      set j [format "%-.7f" $mom_tool_axis(1)]
      set k [format "%-.7f" $mom_tool_axis(2)]

      # Check to output this error only once per path

      if {[info exists prev_error_path]} {
            if {$prev_error_path == $mom_path_name} { return $g_plane }
      }
      MOM_output_to_listing_device \
      "ERROR! PATH - $mom_path_name has invalid tool axis vector ($i,$j,$k)"
      MOM_output_to_listing_device \
      "3-axis Mill machine cannot position the tool to this orientation"
      MOM_output_to_listing_device \
      "The output will be incorrect!!"

      set prev_error_path $mom_path_name
  } else {
      set g_plane 18
  }

  return $g_plane
}


#=============================================================
proc CHECK_TOOL_AXIS {} {
#      .
#=============================================================
  global mom_tool_axis mom_prev_tool_axis

  set I [format "%-.7f" $mom_tool_axis(0)]
  set prev_I [format "%-.7f" $mom_prev_tool_axis(0)]
  set J [format "%-.7f" $mom_tool_axis(1)]
  set prev_J [format "%-.7f" $mom_prev_tool_axis(1)]
  set K [format "%-.7f" $mom_tool_axis(2)]
  set prev_K [format "%-.7f" $mom_prev_tool_axis(2)]

  if {$I == $prev_I && $J == $prev_J && $K == $prev_K} {
    return 0
  } else {
    return 1
  }
}


#
############################################################
#
proc ATAN {v1 v2} {

  set rad2deg [expr 90.0 / asin(1.0)]

  set x $v2
  set y $v1

  if {[EQ_is_zero $x] && [EQ_is_zero $y]} {
      set angle 0.0
      return $angle
  }

  set angle [expr atan2($y,$x) * $rad2deg]

  if {[EQ_is_lt $angle 0.0]} {
      set angle [expr $angle + 360]
  }

  return $angle
}

#=============================================================
proc ARCTAN { y x } {
#=============================================================
  global PI

  if {[EQ_is_zero $y]} {
      if {$x < 0.0} { return $PI }
      return 0.0
  }
  if {[EQ_is_zero $x]} {
      if {$y < 0.0} {return [expr $PI*1.5]}
      return [expr $PI*.5]
  }
  set ang [expr atan ($y/$x)]
  if {$x > 0.0 && $y < 0.0} {return [expr $ang+$PI*2.0]}
  if {$x < 0.0 && $y < 0.0} {return [expr $ang+$PI]}
  if {$x < 0.0 && $y > 0.0} {return [expr $ang+$PI]}

  return $ang
}


#=============================================================
proc SET_SIGN_OF_RADIUS { } {
#=============================================================
  global mom_arc_radius
  global mom_arc_angle

  if {$mom_arc_angle > 180.0} {
      set mom_arc_radius [expr ( -1.0 * $mom_arc_radius) ]
  } else {
      set mom_arc_radius [expr abs($mom_arc_radius)]
  }
}


#=============================================================
proc VMOV { n p1 p2 } {
#=============================================================
  upvar $p1 v1 ; upvar $p2 v2

   for {set i 0} {$i < $n} {incr i} {
      set v2($i) $v1($i)
   }
}

#=============================================================
proc VMAX { n p1 } {
#=============================================================
  upvar $p1 v1 ;

   set val $v1(0)
   for {set i 1} {$i < $n} {incr i} {
      if {[EQ_is_lt $val $v1($i) ]} { set val $v1($i); }
   }
   return $val
}

#=============================================================
proc VMIN { n p1 } {
#=============================================================
  upvar $p1 v1 ;

   set val $v1(0)
   for {set i 1} {$i < $n} {incr i} {
      if {[EQ_is_gt $val $v1($i) ]} { set val $v1($i); }
   }
   return $val
}



#
##################################################################
#
#=============================================================
proc PB_CMD_pause { } {
#=============================================================
  set cam_aux_dir  [MOM_ask_env_var UGII_CAM_AUXILIARY_DIR]

  if { [file exists ${cam_aux_dir}ugwish.exe] && [file exists ${cam_aux_dir}mom_pause.tcl] } {
    exec ${cam_aux_dir}ugwish.exe ${cam_aux_dir}mom_pause.tcl
  }
}
#
#=============================================================
proc PAUSE { args } {
#=============================================================
  global env

  if { [info exists env(PB_SUPPRESS_UGPOST_DEBUG)] &&  $env(PB_SUPPRESS_UGPOST_DEBUG) == 1 } {
return
  }


  set cam_aux_dir  [MOM_ask_env_var UGII_CAM_AUXILIARY_DIR]

  global tcl_platform

  if [string match "*windows*" $tcl_platform(platform)] {
     set ug_wish "ugwish.exe"
  } else {
     set ug_wish ugwish
  }

  if { [file exists ${cam_aux_dir}$ug_wish] && [file exists ${cam_aux_dir}mom_pause.tcl] } {

     set title ""
     set msg ""

     if { [llength $args] == 1 } {
       set msg [lindex $args 0]
     }

     if { [llength $args] > 1 } {
       set title [lindex $args 0]
       set msg [lindex $args 1]
     }

     exec ${cam_aux_dir}$ug_wish ${cam_aux_dir}mom_pause.tcl $title $msg
  }
}




#------------------------------------------------------------------------------
# Local Procedures for use in this posts
#------------------------------------------------------------------------------



#==============================================================
#   ()
#==============================================================

#==============================================================
proc  minmaxHEIDENHAIN { } {
# Author : Kondratenko Elena
#  \    HEIDENHAIN
#7 BLK FORM 0.1 Z X-100. Y-100. Z-50.
#8 BLK FORM 0.2 X+100. Y+100. Z0.
#proc  minmaxHEIDENHAIN { fnSource fnDest offset } { ; }
#minmaxHEIDENHAIN  "E:\\tnc.ptp"  "E:\\13tnc.up" 10
#exit
#==============================================================
 set offset 20.0

 global ptp_file_name
 global mom_output_file_directory  mom_output_file_basename
 MOM_close_output_file $ptp_file_name

#     ptp_file_name
set string_file  ""
set var0 ""
global minX maxX minY maxY  minZ maxZ
set  minX  0.0 ;set  maxX 0.0 ; set  minY  0.0 ;set  maxY 0.0 ; set  minZ 0.0 ;set  maxZ 0.0;

set rf [open "$ptp_file_name" "r" ]

set existsBLK 0
set fl 0
set i 1;   gets $rf  string_file
while {![eof $rf] } {

set var0 ""
set st [regexp -nocase -- "BEGIN"  $string_file  var0]
if {$st!=0} {  set fl 1 }

;#    BLK FORM
set st1 [regexp -nocase -- "BLK" $string_file  var0 ]
if {$st1!=0} {  set existsBLK 1 }

if {$fl!=0 && $st1==0} {

   ;#    
   set st [regsub -nocase -- {(;)+(.)*} $string_file  ""  var0 ]
   set string_file  $var0

   #    X ------
   set st [regexp -nocase -- {(X)([- - +])*([0-9])*([.])*([0-9])+}  $string_file  var0 ]
   if {$st!=0} {
     set var10 ""; set var9  "";
     scan $var0 "%1s %f " var9 var10
     #[info exists var10]
     if  { $var10!= ""} {
        if  {$var10<$minX} {  set  minX   $var10 } ; #min
        if  {$var10>$maxX} {  set  maxX   $var10 }; #max
        }
     } ; #    X ----------

   #    Y ------
   set st [regexp -nocase -- {(Y)([- - +])*([0-9])*([.])*([0-9])+}  $string_file  var0 ]
   if {$st!=0} {
     set var10 ""; set var9  "";
     scan $var0 "%1s %f " var9 var10
     #[info exists var10]
     if  { $var10!= ""} {
        if  {$var10<$minY} {  set  minY   $var10 } ; #min
        if  {$var10>$maxY} {  set  maxY   $var10 }; #max
        }
     } ; #    Y ----------

   #    Z ------
   set st [regexp -nocase -- {(Z)([- - +])*([0-9])*([.])*([0-9])+}  $string_file  var0 ]
   if {$st!=0} {
    set var10 "";
    scan $var0 "%1s %f " var9 var10
     if  { $var10!= ""} {
        if  {$var10<$minZ} {  set  minZ   $var10 } ; #min
        if  {$var10>$maxZ} {  set  maxZ   $var10 }; #max
        }
    } ;  #    Z ----------

  incr fl
 }  else  { ;  }
 gets $rf  string_file
 incr i
}

seek  $rf 0 start

#      
#set fnDest [ MOM_ask_unique_filename ]
set fnDest ${mom_output_file_directory}${mom_output_file_basename}_tmpheid.h
if {[file exists $fnDest]} { MOM_remove_file $fnDest }

set ff [open "$fnDest"  "w+" ] ;

   set  minX  [expr $minX-$offset ] ; set  minY  [expr $minY-$offset ] ; set  minZ  [expr $minZ-$offset ] ;
   set  maxX  [expr $maxX+$offset ] ; set  maxY  [expr $maxY+$offset ] ; set  maxZ  [expr $maxZ+$offset ] ;

   set str1 [format "%+.0f" $minX ]  ;  set str2 [format "%+.0f" $maxX ]
   set str3 [format "%+.0f" $minY ]  ;  set str4 [format "%+.0f" $maxY ]
   set str5 [format "%+.0f" $minZ ]  ;  set str6 [format "%+.0f" $maxZ ]

set outputBLK 0 ; #   BLK
set outputstrBLK 0 ; #    BLK
set fl 0;
set i 1; gets $rf  string_file
while {![eof $rf] } {
   set st [regexp -nocase -- "BEGIN"  $string_file  var0]
   if {$st!=0} {  set fl 1 }
   if {$fl!=0} {
     ;#    BLK FORM
     if {$outputBLK==0} {
       if {$existsBLK==0} {
        set outputBLK 1
        puts $ff  $string_file
        puts $ff  "BLK FORM 0.1 Z X$str1 Y$str3 Z$str5"
          puts $ff  "BLK FORM 0.2 X$str2 Y$str4 Z$str6"
          incr outputstrBLK 2
        } else {
        ;#    BLK FORM
         set st1 [regexp -nocase -- "BLK" $string_file  var0 ]
         if {$st1!=0} {
           #set st [regsub -nocase -- {([0-9])+(.)*} $string_file  ""  var0 ]
           set st [regsub -nocase -- {(BLK)+(.)*} $string_file  ""  var0 ]
           if {$outputstrBLK==0} {
            set string_file "${var0}BLK FORM 0.1 Z X$str1 Y$str3 Z$str5"
            incr outputstrBLK
           } elseif {$outputstrBLK==1} {
                set string_file "${var0}BLK FORM 0.2 X$str2 Y$str4 Z$str6"
                incr outputstrBLK
                 }

         }
       }
     }
  }
 puts $ff  $string_file
 incr i ;  gets $rf  string_file
}

puts $ff  $string_file
flush $ff ;close $ff
close $rf ; # close the file

#   
MOM_remove_file $ptp_file_name
#file delete "$fnSource"
#      
catch { file rename "$fnDest"  "$ptp_file_name" }

#tk_messageBox -icon info -message "\nminX=$minX \nmaxX=$maxX \nminY=$minY \nmaxY=$maxY \nminZ=$minZ\nmaxZ=$maxZ" -type ok
return 0
}



#
#    .
#        f=min(fx,fy,fz)
#     -           ,
#           -1 ( )
#
#==============================================================
proc PB_CMD_check_feed_limit_by_axis { fx fy fz } {
#==============================================================
 global mom_pos mom_prev_pos
 global mom_motion_distance
 global feed
 global mom_feed_rate com_feed_rate
 global mom_machine_time mom_event_time

 global dp

 if [EQ_is_zero $mom_motion_distance] { return 0 ; }
 if ![hiset mom_feed_rate] { return 0 ; }
 if [EQ_is_zero $mom_feed_rate] { return 0 ; }

 set vf(0) $fx ; set vf(1) $fy ; set vf(2) $fz ;

#MOM_output_literal "by_axis-> vf=( $vf(0) $vf(1) $vf(2) )"

 set f $feed ; # mom_feed_rate

 for { set ii 0 } { $ii<3 } { incr ii } {
  set dst($ii) [ expr abs($mom_pos($ii)-$mom_prev_pos($ii)) ]
  set df($ii)  [ expr ([EQ_is_zero $dst($ii)]?0:1) ]
  set df($ii)  [ expr ($df($ii)*$f) ]
  if {[EQ_is_gt $vf($ii) 0.]} {
   if {[EQ_is_gt $df($ii) $vf($ii) ]} { set f $vf($ii) ; }
  }
 }

#MOM_output_literal "by_axis-> feed=$feed  (f=$f)=( $df(0) $df(1) $df(2) )"

 set f [ expr floor($f) ] ;

 if {[EQ_is_le $f 0.]} { return 0 ; }

 if {[EQ_is_gt $mom_feed_rate $f ]} {
   set feed $f ;
   set mom_feed_rate $f ;
   set com_feed_rate $f ;
   MOM_reload_variable mom_feed_rate
   #  
   set _tmp 0.0
   if {![ EQ_is_zero $feed ] } {
         set _tmp [ expr $mom_motion_distance/$feed ];
         set mom_machine_time [ expr ( $mom_machine_time - $mom_event_time + $_tmp ) ];
         MOM_reload_variable mom_machine_time
         set mom_event_time $_tmp ;
         MOM_reload_variable mom_event_time
   }
 }

#MOM_output_literal "feed=$feed  ($f)"

 return 0 ;
}


#
#    .
#        f=min(fx,fy,fz)
#     -           ,
#           -1 ( )
#
#  priori_axis=(0,1,2)|(-1,"") -   (X=0,Y=1,Z=2)   -1|""
#
#==============================================================
proc PB_CMD_check_feed_limit_by_axis_ex { fx fy fz priori_axis } {
#==============================================================
 global mom_pos mom_prev_pos
 global mom_motion_distance
 global feed
 global mom_feed_rate com_feed_rate
 global mom_machine_time mom_event_time

 global dp

 if [EQ_is_zero $mom_motion_distance] { return 0 ; }
 if ![hiset mom_feed_rate] { return 0 ; }
 if [EQ_is_zero $mom_feed_rate] { return 0 ; }

 VMAX 3 vf
 VMIN 3 vf

 set pri  [ string toupper "$priori_axis" ]
 switch $pri {
  "0" -
  "X" {
         set vf(0) $fx ; set vf(1) $fy ; set vf(2) $fz ;
      }
  "1"  -
  "Y" {
  	     set vf(0) $fx ; set vf(1) $fy ; set vf(2) $fz ;
      }
  "2"  -
  "Z" {
  	     set vf(0) $fx ; set vf(1) $fy ; set vf(2) $fz ;
      }
 default {
 	   set vf(0) $fx ; set vf(1) $fy ; set vf(2) $fz ;
 	 }
 }

#MOM_output_literal "by_axis-> vf=( $vf(0) $vf(1) $vf(2) )"

 set f $feed ; # mom_feed_rate

 for { set ii 0 } { $ii<3 } { incr ii } {
  set dst($ii) [ expr abs($mom_pos($ii)-$mom_prev_pos($ii)) ]
  set df($ii)  [ expr ([EQ_is_zero $dst($ii)]?0:1) ]
  set df($ii)  [ expr ($df($ii)*$f) ]
  if {[EQ_is_gt $vf($ii) 0.]} {
   if {[EQ_is_gt $df($ii) $vf($ii) ]} { set f $vf($ii) ; }
  }
 }

#MOM_output_literal "by_axis-> feed=$feed  (f=$f)=( $df(0) $df(1) $df(2) )"

 set f [ expr floor($f) ] ;

 if {[EQ_is_le $f 0.]} { return 0 ; }

 if {[EQ_is_gt $mom_feed_rate $f ]} {
   set feed $f ;
   set mom_feed_rate $f ;
   set com_feed_rate $f ;
   MOM_reload_variable mom_feed_rate
   #  
   set _tmp 0.0
   if {![ EQ_is_zero $feed ] } {
         set _tmp [ expr $mom_motion_distance/$feed ];
         set mom_machine_time [ expr ( $mom_machine_time - $mom_event_time + $_tmp ) ];
         #MOM_reload_variable mom_machine_time
         set mom_event_time $_tmp ;
         MOM_reload_variable mom_event_time
   }
 }

#MOM_output_literal "feed=$feed  ($f)"

 return 0 ;
}



#
#      .
#        .
#   Fmax(i)=(maxfx maxfy maxfz)
#   F(i)=(ds(i)/ds)*F
#   if (F(i)>Fmax(i)) F=df(i)=ds/ds(i)*Fmax(i)
#   F.
#
#==============================================================
proc PB_CMD_check_feed_limit_by_limit { maxfx maxfy maxfz } {
#==============================================================
 global mom_pos mom_prev_pos
 global mom_motion_distance
 global feed
 global mom_feed_rate com_feed_rate
 global mom_machine_time mom_event_time

 global dp

 if [EQ_is_zero $mom_motion_distance] { return 0 ; }
 if ![hiset mom_feed_rate] { return 0 ; }
 if [EQ_is_zero $mom_feed_rate] { return 0 ; }

 set vfmax(0) $maxfx ; set vfmax(1) $maxfy ; set vfmax(2) $maxfz ;
 set vfmin(0) 0. ; set vfmin(1) 0. ; set vfmin(2) 0. ;

 set f $mom_feed_rate

 for { set ii 0 } { $ii<3 } { incr ii } {
  set dst($ii) [ expr abs($mom_pos($ii)-$mom_prev_pos($ii)) ]
  set df($ii)  [ expr ($dst($ii)/$mom_motion_distance*$f) ]
  if {[EQ_is_gt $df($ii) $vfmax($ii) ]} {
        set vfmin($ii) $vfmax($ii);
        if ![EQ_is_zero $dst($ii)] {
                set vfmin($ii) [ expr ($mom_motion_distance/$dst($ii)*$vfmax($ii)) ] ;
                set f $vfmin($ii) ;
        }
  }
 }

# MOM_output_literal "by_limit-> feed=$feed  (v=$f)"

 set f [ expr int($f) ] ;

 if {[EQ_is_le $f 0.]} { return 0 ; }

 if {[EQ_is_gt $feed $f ]} {
   set feed $f ;
   set mom_feed_rate $f ;
   set com_feed_rate $f ;
   MOM_reload_variable mom_feed_rate
   #  
   set _tmp 0.0
   if {![ EQ_is_zero $feed ] } {
         set _tmp [ expr $mom_motion_distance/$feed ];
         set mom_machine_time [ expr ( $mom_machine_time - $mom_event_time + $_tmp ) ];
         set mom_event_time $_tmp ;
         MOM_reload_variable mom_event_time
   }
 }

 return 0 ;
}


#
#   
#
#==============================================================
proc PB_CMD_calc_motion_distance { } {
#==============================================================
 global mom_motion_distance
 global distance
 if {![info exists distance]} { set distance 0.0 }
 if {![info exists mom_motion_distance]} { return 0.0 }
 set distance [ expr $distance + $mom_motion_distance ]

 return $distance
}


#
#  -  
#
#==============================================================
proc PB_CMD_calc_minmax { } {
#==============================================================
 global mom_pos
 set ax 6

 global min_pos  max_pos
#  -
 for { set ii 0 } {$ii<$ax} { incr ii } {
  if {![info exists min_pos($ii)]} { set min_pos($ii) 9999999.9999 }
  if {![info exists max_pos($ii)]} { set max_pos($ii) -9999999.9999 }

  if {[info exists mom_pos($ii)]} {
   if {$mom_pos($ii)<$min_pos($ii)} { set min_pos($ii) $mom_pos($ii) ; } ; #min
   if {$mom_pos($ii)>$max_pos($ii)} { set max_pos($ii) $mom_pos($ii) ; } ; #max
  }
 }

 global mom_motion_type
 if {$mom_motion_type ==  "CYCLE"} {
  for { set ii 0 } {$ii<3} { incr ii } {
   if {[info exists mom_cycle_rapid_to_pos($ii)]} {
    if {$mom_cycle_rapid_to_pos($ii) < $min_pos($ii)} {set min_pos($ii) $mom_cycle_rapid_to_pos($ii)}
    if {$mom_cycle_rapid_to_pos($ii) > $max_pos($ii)} {set max_pos($ii) $mom_cycle_rapid_to_pos($ii)}
   }
  }
  set ii 2
  if {[info exists mom_cycle_feed_to_pos($ii)]} {
    if {$mom_cycle_feed_to_pos($ii) < $min_pos($ii)} {set min_pos($ii) $mom_cycle_feed_to_pos($ii)}
    if {$mom_cycle_feed_to_pos($ii) > $max_pos($ii)} {set max_pos($ii) $mom_cycle_feed_to_pos($ii)}
  }
  if {[info exists mom_cycle_retract_to_pos($ii)]} {
    if {$mom_cycle_retract_to_pos($ii) < $min_pos($ii)} {set min_pos($ii) $mom_cycle_retract_to_pos($ii)}
    if {$mom_cycle_retract_to_pos($ii) > $max_pos($ii)} {set max_pos($ii) $mom_cycle_retract_to_pos($ii)}
  }
 }

 return 0
}


#
#  delta-axis
#
#==============================================================
proc PB_CMD_calc_delta_axis { } {
#==============================================================
 global mom_current_motion
 global mom_pos mom_prev_pos
 global mom_mcs_goto
 global mom_nxt_motion_event
 global mom_nxt_mcs_goto

 global dp dpn
 set ax 6

 for { set ii 0 } { $ii<$ax } { incr ii } {
   if {![info exists dp($ii)]} { set dp($ii) 0. ; }
 }

 if {[info exists mom_current_motion]} {

  ##VEC3_sub mom_pos mom_prev_pos dp ; # if ax==3

  for { set ii 0 } { $ii<$ax } { incr ii } {
   if {((![info exists mom_prev_pos($ii)])&&([info exists mom_pos($ii)]))} {
         set mom_prev_pos($ii) $mom_pos($ii) ;
   }
   if {[info exists mom_pos($ii)]} {
         set dp($ii) [ expr $mom_pos($ii)-$mom_prev_pos($ii) ] ;
   }
  }
 }

 for { set ii 0 } { $ii<$ax } { incr ii } { set dpn($ii) $dp($ii) ; }

 if {[info exists mom_nxt_motion_event]} {
  #if {[string compare $mom_nxt_motion_event "none" ]!=0} { ; }

  ##VEC3_sub mom_nxt_mcs_goto mom_pos dpn ; # if ax==3

  for { set ii 0 } { $ii<$ax } { incr ii } {
   if {[info exists mom_mcs_goto($ii)]&&[info exists mom_nxt_mcs_goto($ii)]} {
         set dpn($ii) [ expr $mom_nxt_mcs_goto($ii)-$mom_mcs_goto($ii) ] ;
   }
  }
 } ; # end [info exists mom_nxt_motion_event]

 # 
 for { set ii 0 } { $ii<$ax } { incr ii } {
   set dp($ii)  [ format "%.4f" $dp($ii) ] ;
   set dpn($ii) [ format "%.4f" $dpn($ii) ] ;
 }

 return 0
}


#
#   X Y Z -   ,   .
#      
#   (c  )  - Coordinate
#          (  ) - CoordinateInt
#
#=============================================================
proc PB_CMD_address_value_int { } {
#=============================================================
 global mom_pos mom_prev_pos
 global mom_output_mode

 for { set ii 0 } { $ii<3 } { incr ii } {
   switch $mom_output_mode {
     ABSOLUTE {
         set dst($ii) $mom_pos($ii) ;
     }
     default {
       set dst($ii) [ expr ($mom_pos($ii)-$mom_prev_pos($ii)) ]
     }
   }
 }

 set osi { X Y Z }
 set ii 0
 foreach ax $osi {
   MOM_set_address_format $ax Coordinate
   set v1 $dst($ii)
   set v2 [ expr int($v1) ]
   if {[EQ_is_equal $v1 $v2]} { MOM_set_address_format $ax CoordinateInt ; }
   incr ii
 }
}


#==============================================================
#    - 
#
#
#==============================================================
proc _routine_check_name { name } {
#==============================================================
 global mom_warning_info

 set p1 0
 set p1 [regexp -nocase -- {(000.000)+} $name ]
 set p2 0
# set p2 [regexp -nocase -- {([0-9]_[0-9])+} $name ] ; # ([0-9])+(_)+([0-9])+
 set p2 [regexp -nocase -- {([0-9][0-9][0-9])+(_)+([0-9][0-9][0-9])+} $name ]
 set p3 0
 set p3 [regexp -nocase -- {([0-9]-[0-9])+} $name ] ; # ([0-9])+(-)+([0-9])+
 set p4 0
 set p4 [regexp -nocase -- {([0-9][0-9][0-9])+} $name ] ; # 000

# MOM_output_to_listing_device " =( $p1  $p2  $p3  $p4 )"
 MOM_log_message " =( $p1  $p2  $p3  $p4 )"

return 0

 #   
 if {$p1!=0 || $p2!=0 || $p3!=0 || $p4==0} {

   set mom_warning_info "   \n $name \n    \n  ''    ."
   append mom_warning_info "\n\n!   ''\n      .\n"

   MOM_output_to_listing_device $mom_warning_info
   MOM_catch_warning

   if {[llength [info commands MOM_info_message ] ]} {
     MOM_info_message "LEFT" $mom_warning_info
   }

 }

 return 0
}

#==============================================================
#   
#
proc _routine_calculation_name { } {
#==============================================================
  global mom_attr_PART_OPU_PART_NAME
  global mom_opu_part_name

  set opu_part_name ""

  if {[ info exists mom_attr_PART_OPU_PART_NAME ] != 0} {
     set opu_part_name [ string trim $mom_attr_PART_OPU_PART_NAME ]
     #MOM_output_to_listing_device "mom_attr_PART_OPU_PART_NAME - OPU_PART_NAME=$opu_part_name"
  } elseif {[ info exists mom_opu_part_name ] != 0} {
     set opu_part_name [ string trim $mom_opu_part_name ]
     #MOM_output_to_listing_device "mom_opu_part_name - OPU_PART_NAME=$opu_part_name"
  }

  return $opu_part_name
}

#=============================================================
proc PB_part_name { } {
# Author : Kondratenko Elena
#         
#    Iman -   
#       -   
#=============================================================
   set nm_part "" ; #  

   set nm_part_opu ""
#    
   if {[llength [info commands _routine_calculation_name] ]!=0} {
    set nm_part_opu [ _routine_calculation_name ]
    ;#if { $nm_part_opu != "" } { return $nm_part_opu ; }
   }

#=============================================================

#  UTF8->ASCII
#
# "__"=(string)""
# "__"=(string)""
# "_ _"=(string)"00-Jan-0000"
# "_ _"=(string)"T7.92.2023.021.001.73/B- 2"
# "_ _"=(string)"1163"
# "__"=(string)"T7.92.2023.021.001.73"
# "__"=(string)"  "
# "__"=(string)" 5"
# "__"=(string)" 2"
# "__"=(string)" 1163 30  1-92-161-90"
# "_  _"=(string)""
# "_ _"=(string)"T7-20-150-05 NC"

##
##  6  2007 
##
## global mom_________ ; # =
## global mom__________ ; # =
## global mom_______________ ; # = 00-Jan-0000
## global mom____________________ ; # = T7.92.2023.021.001.73/B- 2
## global mom__________________ ; # = 1163
## global mom______________ ; # = T7.92.2023.021.001.73
## global mom_____________ ; # =   
## global mom________ ; # =  5
## global mom_______________ ; # =  2
## global mom___________ ; # =  1163 30  1-92-161-90
## global mom_______________________ ; # =
## global mom_____________ ; # = T7-20-150-05 NC
##
##    if {[ info exists mom____________________ ] != 0} {
##      if {[ regsub -all -- {( )+}  $mom____________________ "" var1 ]} {
##        if { $var1 == "" } { set mom____________________ "" }
##      }
##      if { $mom____________________ != "" } { set nm_part $mom____________________ ; }
##    }
##
##    #MOM_output_to_listing_device "  RRJ: nm_part       = $nm_part "
##
##    if { $nm_part != "" } {
##
##     #    
##     if {[llength [info commands _routine_check_name] ]!=0} {
##        _routine_check_name $nm_part
##     }
##
##     if { $nm_part_opu != "" } { set nm_part "${nm_part},${nm_part_opu}" ; }
##
##     return $nm_part ;
##    }
##
#=============================================================
# 
global mom_db_seed_part_used ; # = Metric
global mom_db_units ; # =
global mom_db_part_no ; # = T7.92.2023.021.001.73
global mom_db_part_rev ; # = B
global mom_db_part_name ; # =  2
global mom_db_part_desc ; # =  2
global mom_db_part_type ; # = sdb_DetailItem
global mom_db_dataset_id ; # =
global mom_db_dataset_rev ; # =
global mom_control1 ; # =
global mom_control2 ; # =
global mom_gabarits ; # =
global mom_instructions ; # =
global mom_marking ; # =
global mom_material ; # =
global mom_note1 ; # =
global mom_note2 ; # =
global mom_note3 ; # =
global mom_surface ; # =
global mom_standards ; # =
global mom_thermal ; # =
global mom_tolerance1 ; # =
global mom_tolerance2 ; # =
global mom_weight ; # =

   if {[ info exists mom_db_part_no ] != 0} {
     if {[ regsub -all -- {( )+}  $mom_db_part_no "" var1 ]} {
       if { $var1 == "" } { set mom_db_part_no "" }
     }
     if { $mom_db_part_no != "" } {
      set nm_part $mom_db_part_no
        if {[ info exists mom_db_part_rev ] != 0} {
          if { $mom_db_part_rev != "" } { append nm_part "_${mom_db_part_rev}" ; }
        }
        if {[ info exists mom_db_part_name ] != 0} {
          if { $mom_db_part_name != "" } { append nm_part "-${mom_db_part_name}" ; }
        }
     }
   }

   #MOM_output_to_listing_device " : nm_part       = $nm_part "

   if { $nm_part != "" } {

    #    
    if {[llength [info commands _routine_check_name] ]!=0} {
       _routine_check_name $nm_part
    }

    if { $nm_part_opu != "" } { set nm_part "${nm_part_opu},${nm_part}" ; }

    return $nm_part ;
   }

#=============================================================
#  

   global mom_part_name

   ## 
   #set ls [ list ]
   #set ls [ split $mom_part_name " " ]
   # PN=
   #set pn [ lindex $ls 1 ]
   # PRN=
   #set pn [ lindex $ls 2 ]
   # AN=
   #set pn [ lindex $ls 3 ]

   #  - regsub,regexp
   set nm_part ""   ; #    ()
   set tmp_name ""
   set cam_name ""  ; #  -
   set ver_name ""  ; # 
   set part_name "" ; #  

   if {[regexp -nocase -- {(%UGMGR=)+(.)*}  $mom_part_name  var0 ]!=0} {
      #    AT=
      regsub -nocase -- {(AT=)+(.)*}  $mom_part_name ""  tmp_name

      #     

      #  -
      set v1 ""
      if {[regexp -nocase -- {(AN=)+(.)*} $tmp_name v1 ]!=0} {
        # AN=
        regsub -nocase -- {(AN=)+} $v1 "" cam_name
        set cam_name [ string trim $cam_name ]
        #    AN=
        regsub -nocase -- {(AN=)+(.)*}  $tmp_name ""  tmp_name
      }

      #  -
      set v1 ""
      if {[regexp -nocase -- {(PRN=)+(.)*} $tmp_name v1 ]!=0} {
        # PRN=
        regsub -nocase -- {(PRN=)+} $v1 "" ver_name
        set ver_name [ string trim $ver_name ]
        #    PRN=
        regsub -nocase -- {(PRN=)+(.)*}  $tmp_name ""  tmp_name
      }

      #  
      set v1 ""
      if {[regexp -nocase -- {(PN=)+(.)*} $tmp_name v1 ]!=0} {
        # PN=
        regsub -nocase -- {(PN=)+} $v1 "" part_name
        set part_name [ string trim $part_name ]
        #    PN=
        regsub -nocase -- {(PN=)+(.)*}  $tmp_name ""  tmp_name
      }

      # 
      set nm_part ${cam_name}
      if {$cam_name==""} { set nm_part ${part_name} ; }
      if {$ver_name!=""} { append nm_part "_${ver_name}" ; }

      #    
      if {[llength [info commands _routine_check_name] ]!=0} {
          _routine_check_name $nm_part
      }

   } else {
    set nm_part $mom_part_name
    set nm_part [ file tail $nm_part ]
    #set nm_part [ file rootname $nm_part  ]
  }

 if { $nm_part_opu != "" } { set nm_part "${nm_part_opu},${nm_part}" ; }

# MOM_output_to_listing_device "  - mom_part_name = $mom_part_name "
# MOM_output_to_listing_device "  - nm_part       = $nm_part "

 return $nm_part
}


#=============================================================
proc PB_part_name_ex { } {
# Author : Kondratenko Elena
#         
#    Iman -   
#       -   
#=============================================================
   set nm_part "" ; #  

   set nm_part_opu ""
#    
   if {[llength [info commands _routine_calculation_name] ]!=0} {
    set nm_part_opu [ _routine_calculation_name ]
    ;#if { $nm_part_opu != "" } { return $nm_part_opu ; }
   }

#=============================================================
#  

   global mom_part_name

   #  - regsub,regexp
   set nm_part ""   ; #    ()
   set tmp_name ""
   set cam_name ""  ; #  -
   set ver_name ""  ; # 
   set part_name "" ; #  

   if {[regexp -nocase -- {(%UGMGR=)+(.)*}  $mom_part_name  var0 ]!=0} {
      #    AT=
      regsub -nocase -- {(AT=)+(.)*}  $mom_part_name ""  tmp_name

      #     

      #  -
      set v1 ""
      if {[regexp -nocase -- {(AN=)+(.)*} $tmp_name v1 ]!=0} {
        # AN=
        regsub -nocase -- {(AN=)+} $v1 "" cam_name
        set cam_name [ string trim $cam_name ]
        #    AN=
        regsub -nocase -- {(AN=)+(.)*}  $tmp_name ""  tmp_name
      }

      #  -
      set v1 ""
      if {[regexp -nocase -- {(PRN=)+(.)*} $tmp_name v1 ]!=0} {
        # PRN=
        regsub -nocase -- {(PRN=)+} $v1 "" ver_name
        set ver_name [ string trim $ver_name ]
        #    PRN=
        regsub -nocase -- {(PRN=)+(.)*}  $tmp_name ""  tmp_name
      }

      #  
      set v1 ""
      if {[regexp -nocase -- {(PN=)+(.)*} $tmp_name v1 ]!=0} {
        # PN=
        regsub -nocase -- {(PN=)+} $v1 "" part_name
        set part_name [ string trim $part_name ]
        #    PN=
        regsub -nocase -- {(PN=)+(.)*}  $tmp_name ""  tmp_name
      }

      # 
      set nm_part ${cam_name}
      if {$cam_name==""} { set nm_part ${part_name} ; }
      if {$ver_name!=""} { append nm_part "_${ver_name}" ; }

      #    
      if {[llength [info commands _routine_check_name] ]!=0} {
          _routine_check_name $nm_part
      }

   } else {
    set nm_part $mom_part_name
    set nm_part [ file tail $nm_part ]
    #set nm_part [ file rootname $nm_part  ]
  }

 if { $nm_part_opu != "" } { set nm_part "${nm_part_opu},${nm_part}" ; }

# MOM_output_to_listing_device "  - mom_part_name = $mom_part_name "
# MOM_output_to_listing_device "  - nm_part       = $nm_part "

 return $nm_part
}


#=============================================================
proc PB_part_material { } {
#=============================================================
# Author : Kondratenko Elena
#          
#   - ""
#=============================================================
   set nm_material "" ; #  

#=============================================================

#  UTF8->ASCII
#
# "__"=(string)""
# "__"=(string)""
# "_ _"=(string)"00-Jan-0000"
# "_ _"=(string)"T7.92.2023.021.001.73/B- 2"
# "_ _"=(string)"1163"
# "__"=(string)"T7.92.2023.021.001.73"
# "__"=(string)"  "
# "__"=(string)" 5"
# "__"=(string)" 2"
# "__"=(string)" 1163 30  1-92-161-90"
# "_  _"=(string)""
# "_ _"=(string)"T7-20-150-05 NC"

global mom_________ ; # =
global mom__________ ; # =
global mom_______________ ; # = 00-Jan-0000
global mom____________________ ; # = T7.92.2023.021.001.73/B- 2
global mom__________________ ; # = 1163
global mom______________ ; # = T7.92.2023.021.001.73
global mom_____________ ; # =   
global mom________ ; # =  5
global mom_______________ ; # =  2
global mom___________ ; # =  1163 30  1-92-161-90
global mom_______________________ ; # =
global mom_____________ ; # = T7-20-150-05 NC

   # __
   if {[ info exists mom___________ ] != 0} {
     if {[ regsub -all -- {( )+}  $mom___________ "" var1 ]} {
       if { $var1 == "" } { set mom___________ "" }
     }
     if { $mom___________ != "" } { set nm_material $mom___________ ; }
   } else {
      #_ _
      if {[ info exists mom__________________ ] != 0} {
        if {[ regsub -all -- {( )+}  $mom__________________ "" var1 ]} {
          if { $var1 == "" } { set mom__________________ "" }
        }
        if { $mom__________________ != "" } { set nm_material $mom__________________ ; }
      }
    }
   #MOM_output_to_listing_device "  RRJ: nm_material       = $nm_material "
   if { $nm_material != "" } { return $nm_material ; }

#=============================================================
# 
global mom_db_seed_part_used ; # = Metric
global mom_db_units ; # =
global mom_db_part_no ; # = T7.92.2023.021.001.73
global mom_db_part_rev ; # = B
global mom_db_part_name ; # =  2
global mom_db_part_desc ; # =  2
global mom_db_part_type ; # = sdb_DetailItem
global mom_db_dataset_id ; # =
global mom_db_dataset_rev ; # =
global mom_control1 ; # =
global mom_control2 ; # =
global mom_gabarits ; # =
global mom_instructions ; # =
global mom_marking ; # =
global mom_material ; # =
global mom_note1 ; # =
global mom_note2 ; # =
global mom_note3 ; # =
global mom_surface ; # =
global mom_standards ; # =
global mom_thermal ; # =
global mom_tolerance1 ; # =
global mom_tolerance2 ; # =
global mom_weight ; # =

   if {[ info exists mom_material ] != 0} {
     if {[ regsub -all -- {( )+}  $mom_material "" var1 ]} {
       if { $var1 == "" } { set mom_material "" }
     }
     if { $mom_material != "" } {
      set nm_material $mom_material
        if {[ info exists mom_gabarits ] != 0} {
            if { $mom_gabarits != "" } { append nm_material "-${mom_gabarits}" ; }
        }
     }
   }
   #MOM_output_to_listing_device " : nm_material       = $nm_material "
   if { $nm_material != "" } { return $nm_material ; }

#=============================================================

 #MOM_output_to_listing_device "  - nm_material       = $nm_material "

 return $nm_material

}


#=============================================================
proc outTime { valueTime } {
# valueTime = 
# Author : Kondratenko Elena
#     -> ::
#=============================================================
  set tm1 [ expr int($valueTime/60.0) ]
  set tm2 [ expr ($valueTime/60.0 - $tm1) * 60.0 ]
  set tm3 [ expr abs(int($tm2) - $tm2) * 60.0 ]
  set tm2 [ expr ceil($tm2) ]
  set str [format "= %.0f h %.0f min " $tm1 $tm2]
  #set str [format "= %.0f h %.0f min %.1f s" $tm1 $tm2 $tm3]
  if {$tm1==0} { set str "" }
  return $str
}


#=============================================================
# pFile -   ,  pFile="" -    MOM_output_literal
# frm   - 1  UPPER -      ,   
# :
#    PB_CMD_up_header "" ""
#    PB_CMD_up_header $ofile ""
#    PB_CMD_up_header $ofile UPPER
#    PB_CMD_up_header "" UPPER
#
#=============================================================
proc PB_CMD_up_header { pFile frm } {
#=============================================================
# Author : Kondratenko Elena
#    
#=============================================================
  global  mom_warning_info
  global  mom_output_file_basename
  global  mom_logname  mom_date
  global  mom_part_name
  global  mom_machine_name
  global  mom_ug_version
  global  mom_sys_control_out  mom_sys_control_in

  set strname "" ;
  if [llength [info commands PB_part_name] ] { set strname [ PB_part_name ] ; }
  set strmaterial "" ;
  if [llength [info commands PB_part_material] ] { set strmaterial [ PB_part_material ] ; }

  set cmdmain "puts \$pFile "
  if {$pFile==""} { set cmdmain "MOM_output_literal" }

  set frm [ MOM_string_toupper $frm ]
  if {$frm=="1" || $frm=="UPPER"} { set frm 1 } else { set frm 0 }

  set str "${mom_sys_control_out}Part=${strname}${mom_sys_control_in}"
  if {frm} { set str [ MOM_string_toupper $str ] }
  eval $cmdmain $str

  set str "${mom_sys_control_out}Material=${strmaterial}${mom_sys_control_in}"
  if {frm} { set str [ MOM_string_toupper $str ] }
  eval $cmdmain $str

  set str "${mom_sys_control_out}Program=${mom_output_file_basename}${mom_sys_control_in}"
  if {frm} { set str [ MOM_string_toupper $str ] }
  eval $cmdmain $str

  set tmp [ clock seconds ]
  set tmp [ clock format $tmp  -format  "%d.%m.%Y - %H:%M" ] ; # "%d.%m.%Y  %H:%M"
  set str "${mom_sys_control_out} ${mom_logname} , Date=${mom_date} ${mom_sys_control_in}"
  if {frm} { set str [ MOM_string_toupper $str ] }
  eval $cmdmain $str

  set str "${mom_sys_control_out}MACHINE=${mom_machine_name}${mom_sys_control_in}"
  if {frm} { set str [ MOM_string_toupper $str ] }
  eval $cmdmain $str

  set str "${mom_sys_control_out}GENERATE=${mom_ug_version}${mom_sys_control_in}"
  if {frm} { set str [ MOM_string_toupper $str ] }
  eval $cmdmain $str

  set str "${mom_sys_control_out}      ${mom_sys_control_in}"
  if {frm} { set str [ MOM_string_toupper $str ] }
  eval $cmdmain $str

  return 0
}


#=============================================================
proc PB_CMD_MOM_string_toupper { } {
#=============================================================

 if {[llength [info commands MOM_string_toupper] ]} { return -1 ; }

 if {[llength [info commands _check_version] ]==0} { return -1 ; }

 set ver [ _check_version ]
 if {(($ver>18)||($ver<0))} { return $ver }

uplevel #0 {

#=============================================================
proc MOM_string_toupper { str } {
#=============================================================
 set str1  [ string toupper $str ]

 return $str1
}

} ;# uplevel

 return 0

}


#
# MOM_check_version
#
#=============================================================
proc _check_version { } {
# Author : Kondratenko Elena
#    Unigraphics
# Unigraphics NX 2.0.6.2   Unigraphics V17.0.2.2
#=============================================================
   global current_version released_on_version
   global mom_check_version
   global mom_ug_version

 set current_version -1
 set val 0
 set tmp 0
 set ver 0
 set str ""

 if {![info exists mom_ug_version]} { return $current_version ; }

 if {[regsub -nocase -- "Unigraphics"  $mom_ug_version "" str ]==0} { return $current_version ; }

 if {[regsub -nocase -- "NX" $str "" val ]} {
  set ver 18 ;
  } elseif {[regsub -nocase -- "V" $str "" val ]} {
  set ver 0 ;
 }
 if {[regexp -nocase -- {([0-9])+([.])*}  $val  tmp ]!=0} {
  set ver [ expr ($ver + int($tmp) ) ]
 }
 set current_version $ver

 # Is it NX ?
## set nx_or_not [split $mom_ug_version]
## if { [lindex $nx_or_not 0] == "NX" || [lindex $nx_or_not 1] == "NX" } {
##      set tmp [regsub -all "v" [MOM_ask_env_var "UGII_FULL_VERSION"] "NX " current_version ]
##  } else {
##      scan $mom_ug_version "Unigraphics V%s" current_version
## }


 return $current_version
}


#
################################################################################
#                     
#
# global mom_update_post_cmds_from_tool

# global mom_lib_attr_value
# global mom_libref

# retrieve Tool number and adjust register for the tool from library

# MOM_ask_library_attributes LIBRARY_TOOL  $mom_libref  ToolNum  AdjReg

# assign the values of the tool number and adjust register to local variables

# set var1 $mom_lib_attr_value(ToolNum)
# set var2 $mom_lib_attr_value(AdjReg)

# actual tool change stuff
# .............
#=============================================================
#    
#=============================================================
proc PB_CMD_tool_info { } {
#=============================================================
  global mom_tool_name mom_tool_diameter
  global mom_tool_corner1_radius mom_tool_corner2_radius
  global mom_tool_flutes_number mom_tool_number mom_tool_adjust_register
  global mom_tool_length mom_tool_z_offset
  global mom_tool_text

  set frmti ".0f"
  set frmtd ".2f"

  set line "TOOL=$mom_tool_name "

  if {[info exists mom_tool_number]} {
    if {$mom_tool_number!=0} { append line [format " N=%d" $mom_tool_number ] ; }
  }

  if {[info exists mom_tool_adjust_register]} {
    if {$mom_tool_adjust_register!=0} { append line [format ".%d" $mom_tool_adjust_register ] ; }
  }

  if {[info exists mom_tool_diameter]} {
    set r [expr $mom_tool_diameter/2.0]
    set frmt $frmtd
    if {[EQ_is_equal $mom_tool_diameter [ expr int($mom_tool_diameter) ] ]} { set frmt $frmti ; }
    append line [format " D=%${frmt}" $mom_tool_diameter ]
  }

  if {[info exists mom_tool_corner1_radius]} {
    if {![ EQ_is_zero $mom_tool_corner1_radius ] } {
      set frmt $frmtd
      if {[EQ_is_equal $mom_tool_corner1_radius [ expr int($mom_tool_corner1_radius) ] ]} { set frmt $frmti ; }
        append line [format " r1=%${frmt}" $mom_tool_corner1_radius ] ;
    }
  }

  if {[info exists mom_tool_corner2_radius]} {
    if {![ EQ_is_zero $mom_tool_corner2_radius ] } {
      set frmt $frmtd
      if {[EQ_is_equal $mom_tool_corner2_radius [ expr int($mom_tool_corner2_radius) ] ]} { set frmt $frmti ; }
        append line [format " r2=%${frmt}" $mom_tool_corner2_radius ] ;
    }
  }

  if {[info exists mom_tool_flutes_number]} {
    if {![ EQ_is_zero $mom_tool_flutes_number ] } { append line [format " z=%d" $mom_tool_flutes_number ] ; }
  }

  if {[info exists mom_tool_length ]} {
    if {![ EQ_is_zero $mom_tool_length ] } {
        set frmt $frmtd
        if {[EQ_is_equal $mom_tool_length [ expr int($mom_tool_length) ] ]} { set frmt $frmti ; }
        append line [format " L=%${frmt}" $mom_tool_length ] ;
    }
  }

  if {[info exists mom_tool_z_offset]} {
    ; # set mom_tool_z_offset 0.0
  }

  if {[info exists mom_tool_text]} {
    if {"$mom_tool_text" != "" } { append line " -$mom_tool_text" ; }
  }

  return "$line"
}


#=============================================================================
proc PB_CMD_save_active_oper_tool_data {} {
#=============================================================================
#  This command saves the attributes of the tool used in the current operation
#  to be post-processed before the generation of the tool list.
#
#  This command will be executed automatically in PB_CMD_create_tool_list.
#
#  You may add any desired MOM variable to the list below to be restored
#  later in your post.
#

   global mom_sys_oper_tool_attr_list
   global mom_sys_oper_tool_attr_saved_arr


  #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  # You may add any MOM variable that needs to be retained for
  # the operation to the list below (using lappend command).
  #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   set mom_sys_oper_tool_attr_list [list]

   lappend mom_sys_oper_tool_attr_list  mom_tool_number
   lappend mom_sys_oper_tool_attr_list  mom_tool_length_adjust_register
   lappend mom_sys_oper_tool_attr_list  mom_tool_name
   lappend mom_sys_oper_tool_attr_list  mom_operation_name


   foreach mom_var $mom_sys_oper_tool_attr_list {
      global $mom_var
      if [info exists $mom_var] {
         set mom_sys_oper_tool_attr_saved_arr($mom_var) [eval format %s $$mom_var]
      }
   }
}


#=============================================================================
proc PB_CMD_restore_active_oper_tool_data {} {
#=============================================================================
#  This command restores the attributes of the tool used in the current operation
#  to be post-processed before the generation of the tool list.
#  The attributes have been saved in proc PB_CMD_save_active_oper_tool_data.
#
#  This command wil be executed automatically in PB_CMD_create_tool_list.
#
#
   global mom_sys_oper_tool_attr_list
   global mom_sys_oper_tool_attr_saved_arr

   foreach mom_var $mom_sys_oper_tool_attr_list {
      global $mom_var
      if [info exists mom_sys_oper_tool_attr_saved_arr($mom_var)] {
         set $mom_var $mom_sys_oper_tool_attr_saved_arr($mom_var)
      }
   }
}

#=============================================================================
proc PB_CMD_init_oper_tool_time {} {
#=============================================================================
#  This command will be executed automatically in the "Start of Path" marker
#  to reset the machining time for the operation.
#
#
   global mom_machine_time
   global mom_sys_prev_machine_time

   set mom_sys_prev_machine_time $mom_machine_time
}

#=============================================================================
proc PB_CMD_set_oper_tool_time {} {
#=============================================================================
#  This command will be executed automatically in the "End of Path" marker
#  to set the machining time accumulated on the tool used in the operation.
#
#
   global mom_machine_time
   global mom_tool_name mom_operation_name mom_sys_tool_time
   global mom_sys_prev_machine_time

   if { ![info exists mom_sys_prev_machine_time] } {
      set mom_sys_prev_machine_time 0
   }

   set curr_machine_time [expr $mom_machine_time - $mom_sys_prev_machine_time]
   set mom_sys_prev_machine_time $mom_machine_time

   set mom_sys_tool_time($mom_tool_name,$mom_operation_name) $curr_machine_time
   lappend mom_sys_tool_time($mom_tool_name,oper_list) $mom_operation_name

#  
   global tool_data_list
   if { ![info exists tool_data_list] } { set tool_data_list [list] }
   set ind [ lsearch $tool_data_list $mom_tool_name ]
   if {$ind<0} { lappend tool_data_list $mom_tool_name }

#  
   global oper_data_list
   if { ![info exists oper_data_list] } { set oper_data_list [list] }
   lappend oper_data_list $mom_operation_name

}


#=============================================================================
proc PB_CMD_print_oper_tool_time { } {
#=============================================================================
# Fetch tool time data from the post.
# This info is only available when tool list is created at the end of a program.
#=============================================================================
 global mom_sys_tool_list_output_type
 global mom_sys_tool_time
 global tool_data_list
 global oper_data_list

 set tool_time ""

 if {![info exists mom_sys_tool_time]} { return ; }
 if {![info exists tool_data_list]} { return ; }
 if {![info exists oper_data_list]} { return ; }

#   "ORDER_IN_USE"     - List tools used in the program in the order of operations.
#   "ALL_UNIQUE"       - List all unique tools once for each in the order of use.
#   "GROUP_BY_TYPE"    - List tools in groups of different tool types.
 set mom_sys_tool_list_output_type "GROUP_BY_TYPE" ;
 if {![info exists mom_sys_tool_list_output_type]} { set mom_sys_tool_list_output_type "ORDER_IN_USE" ; }

 MOM_output_to_listing_device "\$\$------------------------------------------------------------------------------------"

 switch $mom_sys_tool_list_output_type {
  "ORDER_IN_USE" {
    # Tool time per operations.
    PB_CMD_print_by_order_oper_tool_time
  }

  default {
    # Accumulate tool time from all operations using this tool.
    PB_CMD_print_by_group_oper_tool_time
  }

 } ; # switch

 MOM_output_to_listing_device "\$\$------------------------------------------------------------------------------------"

}


#=============================================================================
proc PB_CMD_print_by_order_oper_tool_time { } {
#=============================================================================
# Fetch tool time data from the post.
# This info is only available when tool list is created at the end of a program.
#=============================================================================
 global mom_sys_tool_time
 global tool_data_list
 global oper_data_list

 set tool_time ""

 if {![info exists mom_sys_tool_time]} { return ; }
 if {![info exists tool_data_list]} { return ; }
 if {![info exists oper_data_list]} { return ; }

 # Tool time per operations.
 set tool_time_base_sum  0.0
 foreach oper $oper_data_list {
  set oper_name [format "%-30s" $oper]
  foreach tool $tool_data_list {
   set tool_name [format "%-20s" $tool]
   if [info exists mom_sys_tool_time($tool,$oper)] {
      set tool_time $mom_sys_tool_time($tool,$oper)
      set tool_time [expr   double($tool_time)  ]
      set tool_time_base_sum [expr $tool_time_base_sum + $tool_time]
      set tool_time [format "%-10.2f" $tool_time]
      set tool_time_sum_str [format "%-10.2f" $tool_time_base_sum]
      set str "\t $oper_name  $tool_name  =$tool_time ($tool_time_sum_str)"
      MOM_output_to_listing_device $str
   }
  }
 }

 return 0
}


#=============================================================================
proc PB_CMD_print_by_group_oper_tool_time { } {
#=============================================================================
# Fetch tool time data from the post.
# This info is only available when tool list is created at the end of a program.
#=============================================================================
 global mom_sys_tool_time
 global tool_data_list
 global oper_data_list

 set tool_time ""

 if {![info exists mom_sys_tool_time]} { return ; }
 if {![info exists tool_data_list]} { return ; }
 if {![info exists oper_data_list]} { return ; }

   # Accumulate tool time from all operations using this tool.
   set tool_time_base_sum  0.0
   foreach tool $tool_data_list {
     set tool_name [format "%-20s" $tool]

     MOM_output_to_listing_device "$tool_name ->"

     if [info exists mom_sys_tool_time($tool,oper_list)] {

       set tool_time_sum 0
       foreach oper $mom_sys_tool_time($tool,oper_list) {
         set oper_name [format "%-30s" $oper]

         # Tool time per operations.
         set tool_time $mom_sys_tool_time($tool,$oper)

         set tool_time [expr   double($tool_time)  ]
         set tool_time [format "%-10.2f" $tool_time]

         # Accumulate tool time from all operations using this tool.
         set tool_time_sum [expr $tool_time_sum + $mom_sys_tool_time($tool,$oper)]

         set tool_time_sum_str [format "%-10.2f" $tool_time_sum]

         set str "\t $oper_name  $tool_name  =$tool_time ($tool_time_sum_str)"
         MOM_output_to_listing_device $str
       }

      set tool_time_base_sum [ expr ($tool_time_base_sum+$tool_time_sum) ]
      set sum_str [format "\t %-60s summa T=%-10.2f" " " $tool_time_base_sum]
      MOM_output_to_listing_device "$sum_str"

     }

   }

 return 0

}


#
# PB_CMD_check
#=============================================================
proc PB_CMD_check_output_file { } {
# Author :
#    
#=============================================================
 global mom_logname mom_event_handler_file_name mom_definition_file_name
 global mom_output_file_directory mom_output_file_basename mom_output_file_suffix
 global mom_sys_output_file_suffix
 global mom_sys_list_file_suffix
 global mom_machine_name

 global mom_warning_info

#     
# set sysuser [ string tolower $mom_logname ]
# if {[ string compare "chudoyakoveb68" $sysuser ]!=0} { return 0 ; }
#
# !!!!
# mom_output_file_suffix     -     
# mom_sys_output_file_suffix -            (tcl)
#
# set s1 "mom_machine_name=$mom_machine_name"
# set s2 "mom_output_file_suffix=$mom_output_file_suffix"
# set s3 "mom_sys_output_file_suffix=$mom_sys_output_file_suffix"
# MOM_output_to_listing_device "$s1\n$s2\n$s3"
#

 #           .
 if {![hiset mom_output_file_suffix]} { return 0 }

 set ext   "" ; #  
 set extpp "" ; #  
 set outmm 0  ; #   

 if {[string length $mom_output_file_suffix] > 0} {
    set ext "${mom_output_file_suffix}"
    set extpp "${ext}"
 }

 if {[hiset mom_sys_output_file_suffix]} {
  if {[string length $mom_sys_output_file_suffix] > 0} {
    set extpp "${mom_sys_output_file_suffix}"
  }
 }

#if {[hiset mom_sys_list_file_suffix]} {
#  if {[string length $mom_sys_list_file_suffix] > 0} {
#     set extlist "${mom_sys_list_file_suffix}"
#     if {0!=[ _check_output_file_suffix $ext $extlist ]} {
#       MOM_abort "   ($ext)\n  \n     ($extlist)"
#     }
#  }
#}

 set str_out1 ""
 set str_out2 ""
 set str_out3 ""

#      :    
 set mach  [ string toupper $mom_machine_name ]
 switch $mach {
  "H33"
           {
              set outmm [ _check_output_file_suffix $ext $extpp ] ;
              _check_name_limit $mom_output_file_basename 8 ;
             }
  "ALPHA3X" -
  "ALPHA"
           {
              _check_name_limit $mom_output_file_basename 8 ;
             }
  "MTC200"
           {
              set outmm [ _check_output_file_suffix $ext $extpp ] ;
              _check_name_limit $mom_output_file_basename 32 ;
             }
  "EXXACT51" -
  "NC1325IP"
           {  set outmm [ _check_output_file_suffix $ext $extpp ] ;  }
  "MAG3.EX"
           {
           	  set outmm [ _check_output_file_suffix $ext $extpp ] ;
           	  _check_name_fanuc_prof5 $mom_output_file_basename
           	 }
  "GMX200_LINEAR" -
  "RFP2C"  -
  "VF5HS"  -
  "VSTAR"
           {
           	  set outmm [ _check_output_file_suffix $ext $extpp ] ;
           	  _check_name_limit $mom_output_file_basename 24 ;
           	  ;# _check_name_siemens $mom_output_file_basename
           	    }
  "VARIAXIS630"
           { set outmm [ _check_output_file_suffix $ext $extpp ] ; }
  "DMF_500_LINEAR" -
  "DMU50EV"        -
  "DMU_63V"        -
  "DMU125PA"       -
  "DMU125P"        -
  "DMU200P"        -
  "FSQ80KR"
           {
                 set outmm [ _check_output_file_suffix $ext $extpp ] ;
                 _check_name_limit $mom_output_file_basename 16 ;
                }
  "DMU_35M" {
                 set outmm [ _check_output_file_suffix $ext $extpp ] ;
                 _check_name_limit $mom_output_file_basename 8 ;
                }
 default
    { ; }
 }

 #   
 if {$outmm!=0} {

   set mom_warning_info "  \n   $mach \n   *.${extpp} \n"

   MOM_output_to_listing_device $mom_warning_info
   MOM_catch_warning

   if {[llength [info commands MOM_info_message ] ]} {
     MOM_info_message "LEFT" $mom_warning_info
   }

 }

 return 0
}


#=============================================================
proc _check_output_file_suffix { ext extpp } {
#=============================================================
  set ret 0
  set s1  [ string toupper $ext ]
  set s2  [ string toupper $extpp ]
  if {[ string compare $s1 $s2 ]!=0} { set ret 1 ; }
  return $ret
}


#
#   -     
#
#==============================================================
proc _check_name_limit { name limit_max } {
#==============================================================
 global mom_warning_info

 set p 0

 set l [ string length $name ]

 if {$l>$limit_max} { set p 1 ; }

 #   
 if {$p!=0} {

   set mom_warning_info " : $name \n-    \n   \n     $limit_max ."

   MOM_output_to_listing_device $mom_warning_info
   MOM_catch_warning

   if {[llength [info commands MOM_info_message ] ]} {
     MOM_info_message "LEFT" $mom_warning_info
   }

 }

 return $p
}


#
#   -      ( ABxxxxxxxxxxx.mpf )
#
#==============================================================
proc _check_name_siemens { name } {
#==============================================================
 global mom_warning_info

 set p 0

 set str [ string range $name 0 1 ]

 set p [ regexp -nocase -- {[0-9]+} $str ]

 if {$p!=0} {

   set mom_warning_info " : $name \n Siemens:\n The first two characters must be letters (or a letter \n with an underscore character)"

   MOM_output_to_listing_device $mom_warning_info
   MOM_catch_warning

   if {[llength [info commands MOM_info_message ] ]} {
     MOM_info_message "LEFT" $mom_warning_info
   }

 }

 return $p
}


#
#   -      ( Oxxxx.dat )
#
#==============================================================
proc _check_name_fanuc_prof5 { name } {
#==============================================================
 global mom_warning_info

 set p 0

 set str [ string range $name 0 4 ]

 set p [ regexp -nocase -- {(O)+[0-9]+[0-9]+[0-9]+[0-9]+} $str ]

 if {$p==0} {

   set mom_warning_info " : $name \n      :\n"
   append mom_warning_info "\n\t Oxxxx  ,  xxxx - 4x  "
   append mom_warning_info "\n O1000~O7999    "
#   append mom_warning_info "\n O8000~O8999     (  )"

   MOM_output_to_listing_device $mom_warning_info
   MOM_catch_warning

   if {[llength [info commands MOM_info_message ] ]} {
     MOM_info_message "LEFT" $mom_warning_info
   }

 }

 return $p
}


#
# -       -    -
#   PB_CMD_check_sequence -  !! -  Builder
#
#=============================================================
proc PB_CMD_check_sequence_cnc { max_seqnum  possible_seqnum } {
#=============================================================
#       - 
#
global mom_warning_info
global mom_seqnum

#    1-
 global check_sequence_flag
 if {[info exists check_sequence_flag]} { return 0 }

 set tmpNum 0.0
 if {[info exists mom_seqnum]} { set tmpNum [format "%.0f" $mom_seqnum] }
 #MOM_output_to_listing_device " ---- mom_seqnum=$tmpNum"  ;

 set ret 0
 if {$tmpNum>=$max_seqnum} {

   set ret 1
   set check_sequence_flag 1

   set mom_warning_info "\n     >= $max_seqnum !! \n Max=$possible_seqnum !\n"
   #MOM_output_to_listing_device $mom_warning_info

   if {[llength [info commands PB_CMD_Messages ] ]} { PB_CMD_Messages }

 }

 return $ret
}


#
#         
#    : <__>
#    :    
#=============================================================
proc  PB_CMD_file_size { file_name } {
# Author :
#     
#=============================================================
  global ptp_file_name
  global mom_sys_ptp_output

  set sz 0
  if {![info exists mom_sys_ptp_output]} { return $sz ; }
  if {$mom_sys_ptp_output != "ON"} { return $sz ; }

  set file_name [ string trim $file_name ]
  if {$file_name==""} {
    if {![info exists ptp_file_name]} { return $sz ; }
    set file_name $ptp_file_name
  }

  if {![file exists $file_name]} { return $sz ; }

  #!!!
  catch { MOM_close_output_file $file_name }
  #!!!
      if {![file exists $file_name]} { return $sz ; }
      set sz [ file size $file_name ]
      set sn ""
  #!!!
  catch { MOM_open_output_file $file_name }
  #!!!

  set sout $sz
  if {$sout>=1024} {
     set sout [ format "%.2f" [ expr $sout/1024.0 ] ]
     set sn ""
  }

  MOM_output_to_listing_device "      "
  MOM_output_to_listing_device " =$file_name (   =$sout $sn )"
  MOM_output_to_listing_device "      "

  return $sz
}


#
# -           -
#
#   max_file_size -   
#
#      check_file_size_flag
#
#=============================================================
proc PB_CMD_check_file_size { max_file_size } {
#=============================================================
global mom_warning_info
global mom_seqnum

   global opu_file_num_sum ; #    
   if {![info exists opu_file_num_sum]} {return 0;}
   global opu_file_sym_sum ; #      
   if {![info exists opu_file_sym_sum]} {return 0;}

#    1-
 global check_file_size_flag
 if {[info exists check_file_size_flag]} { return 0 }

 set tmpNum 0.0
 if {[info exists mom_seqnum]} { set tmpNum [format "%.0f" $mom_seqnum] }
 #MOM_output_to_listing_device " ---- mom_seqnum=$tmpNum"  ;

 set ret 0
 if {$opu_file_sym_sum>=$max_file_size} {

   set ret 1
   set check_file_size_flag 1

   set sout $max_file_size
   set sn ""
   if {$sout>=1024} {
     set sout [ format "%.2f" [ expr $sout/1024.0 ] ]
     set sn ""
   }

   set mom_warning_info "\n   >= $sout $sn !!\n  =$opu_file_num_sum\n  =$tmpNum\n"
   #MOM_output_to_listing_device $mom_warning_info

   if {[llength [info commands PB_CMD_Messages ] ]} { PB_CMD_Messages }

 }

 return $ret
}


#
#
#
#   max_file_size -
#=============================================================
proc PB_CMD_file_divide_vf5hs { } {
#=============================================================
global mom_warning_info
global mom_seqnum


 set tmpNum 0.0
 if {[info exists mom_seqnum]} { set tmpNum [format "%.0f" $mom_seqnum] }
 #MOM_output_to_listing_device " ---- mom_seqnum=$tmpNum"  ;


 return 0
}



#
# -   X Y Z I J F -      str
#
#============================================
proc PB_CMD_repeat_address { str } {
#  X Y Z F -      str
#============================================
  set str_out ""
  foreach i { X Y Z I J F } {
   #   i ------
   if {0!=[regexp -nocase -- "($i)+"  $str ]} {
    set str_out "$str_out $i"
    MOM_force ONCE $i
   }
  } ; # foreach
  return $str_out
}


#
#   -      - 5 
#    PB_CMD_limit_angle_AB  PB_CMD_limit_angle  PB_CMD_limit_angle_AB_saveout
#
#=============================================================
proc PB_CMD_limit_angle_AB { Amin Amax Bmin Bmax } {
#    4-  5-    (+- Amin Amax Bmin Bmax ()  )
#=============================================================
  global mom_warning_info
  global mom_out_angle_pos
  global mom_pos mom_prev_pos
  global mom_kin_4th_axis_min mom_kin_5th_axis_min
  global mom_kin_4th_axis_max mom_kin_5th_axis_max

  ;#MOM_output_to_listing_device $mom_warning_info  ;
  MOM_set_seq_off
  if {$mom_out_angle_pos(0)>$Amax} {
    set mom_warning_info "     ${Amax}"
    MOM_catch_warning ;
    MOM_output_literal "; !Error! "
  }
  if {$mom_out_angle_pos(0)<$Amin} {
    set mom_warning_info "      ${Amin}"
    MOM_catch_warning ;
    MOM_output_literal "; !Error! "
  }
  if {$mom_out_angle_pos(1)>$Bmax} {
    set mom_warning_info "     ${Bmax}"
    MOM_catch_warning ;
    MOM_output_literal "; !Error! "
  }
  if {$mom_out_angle_pos(1)<$Bmin} {
    set mom_warning_info "      ${Bmin}"
    MOM_catch_warning ;
    MOM_output_literal "; !Error! "
  }
  MOM_set_seq_on

  if {$mom_out_angle_pos(0)>0.0} {
    if {$mom_out_angle_pos(0)>$mom_kin_4th_axis_max} { set mom_kin_4th_axis_max $mom_out_angle_pos(0) ; }
  } elseif {$mom_out_angle_pos(0)<0.0} {
           if {$mom_out_angle_pos(0)<$mom_kin_4th_axis_min} { set mom_kin_4th_axis_min $mom_out_angle_pos(0) ; }
        }

  if {$mom_out_angle_pos(1)>0.0} {
    if {$mom_out_angle_pos(1)>$mom_kin_5th_axis_max} { set mom_kin_5th_axis_max $mom_out_angle_pos(1) ; }
  } elseif {$mom_out_angle_pos(1)<0.0} {
       if {$mom_out_angle_pos(1)<$mom_kin_5th_axis_min} { set mom_kin_5th_axis_min $mom_out_angle_pos(1) ; }
         }

}


#=============================================================
proc PB_CMD_limit_angle {} {
#=============================================================
  global mom_warning_info
  global mom_out_angle_pos
  global mom_pos mom_prev_pos
  global mom_kin_4th_axis_min mom_kin_5th_axis_min
  global mom_kin_4th_axis_max mom_kin_5th_axis_max
  #   4-  5-    (+- angle ()  )
  ;#MOM_output_to_listing_device $mom_warning_info  ;
  MOM_set_seq_off
  set angle 20.5
  if {$mom_out_angle_pos(0)>$angle} {
    set mom_warning_info "     ${angle}"
    MOM_catch_warning ;
    MOM_output_literal " !Error! "
  }
  set angle [ expr (-1.0 * $angle) ]
  if {$mom_out_angle_pos(0)<$angle} {
    set mom_warning_info "      ${angle}"
    MOM_catch_warning ;
    MOM_output_literal " !Error! "
  }
  set angle [ expr abs($angle) ]
  if {$mom_out_angle_pos(1)>$angle} {
    set mom_warning_info "     ${angle}"
    MOM_catch_warning ;
    MOM_output_literal " !Error! "
  }
  set angle [ expr (-1.0 * $angle) ]
  if {$mom_out_angle_pos(1)<$angle} {
    set mom_warning_info "      ${angle}"
    MOM_catch_warning ;
    MOM_output_literal " !Error! "
  }
  MOM_set_seq_on

  if {$mom_out_angle_pos(0)>0.0} {
    if {$mom_out_angle_pos(0)>$mom_kin_4th_axis_max} { set mom_kin_4th_axis_max $mom_out_angle_pos(0) ; }
  } elseif {$mom_out_angle_pos(0)<0.0} {
           if {$mom_out_angle_pos(0)<$mom_kin_4th_axis_min} { set mom_kin_4th_axis_min $mom_out_angle_pos(0) ; }
        }

  if {$mom_out_angle_pos(1)>0.0} {
    if {$mom_out_angle_pos(1)>$mom_kin_5th_axis_max} { set mom_kin_5th_axis_max $mom_out_angle_pos(1) ; }
  } elseif {$mom_out_angle_pos(1)<0.0} {
       if {$mom_out_angle_pos(1)<$mom_kin_5th_axis_min} { set mom_kin_5th_axis_min $mom_out_angle_pos(1) ; }
         }

}


#=============================================================
proc PB_CMD_limit_angle_AB_saveout { } {
#=============================================================
#---- The following procedure lists the tool list with time in commentary data
#=============================================================

  global  mom_kin_4th_axis_min mom_kin_5th_axis_min
  global  mom_kin_4th_axis_max mom_kin_5th_axis_max

   set  mom_kin_4th_axis_min [format "%2.3f" $mom_kin_4th_axis_min ]
   set  mom_kin_4th_axis_max [format "%2.3f" $mom_kin_4th_axis_max ]
   set  mom_kin_5th_axis_min [format "%2.3f" $mom_kin_5th_axis_min ]
   set  mom_kin_5th_axis_max [format "%2.3f" $mom_kin_5th_axis_max ]

   set str1 [ list ]
   ; # lappend str1 "     \n\n\n\n\n\n\n" ; # "     \n\n\n\n\n\n\n"
   lappend str1 "\n\n================================================================\n\n" ; # "     \n\n\n\n\n\n\n"
   lappend str1 "  COORDINATE AXIS TRAVEL - MINIMUM       MAXIMUM         TOTAL   "
   lappend str1 "           X                                                                "
   lappend str1 "           Y                                                                "
   lappend str1 "           Z                                                                "
   lappend str1 "           A              $mom_kin_4th_axis_min        $mom_kin_4th_axis_max    "
   lappend str1 "           B              $mom_kin_5th_axis_min        $mom_kin_5th_axis_max    "
   lappend str1 "\n\n================================================================\n\n"

   global list_file
   set p [ llength $str1 ]
   for { set i 0} {$i<$p} {incr i} {
     set str [ lindex $str1 $i ]
     MOM_output_to_listing_device  $str
     puts $list_file  $str
   }

   return 0 ;
}


#=============================================================
#
#
# PB_CMD_Messages
#=============================================================
proc PB_CMD_Messages { } {
# Author :
#   
#=============================================================
 global mom_warning_info

 MOM_catch_warning

 if {[llength [info commands MOM_info_message ] ]} {
    MOM_info_message "RIGHT" $mom_warning_info
    return 0
 }

 if {[llength [info commands MOM_ui_message ] ]} {
    MOM_ui_message "WARNING" $mom_warning_info
    return 0
 }

 if {[llength [info commands MOM_box_message ] ]} {
    MOM_box_message $mom_warning_info
    return 0
 }

#   
# -     TCL
# -           TK

 #global auto_path
 #linsert $auto_path end "~/lib"

  set cam_aux_dir  [MOM_ask_env_var UGII_CAM_AUXILIARY_DIR]
  set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR]

  global tcl_platform

  if [string match "*windows*" $tcl_platform(platform)] {
     set ug_wish "ugwish.exe"
  } else {
     set ug_wish ugwish
  }

  set pp_mes_file "${cam_post_dir}/pp_mes.ui.tcl"

  if { [file exists ${cam_aux_dir}$ug_wish] && [file exists $pp_mes_file] } {
     exec ${cam_aux_dir}$ug_wish $pp_mes_file $mom_warning_info
     return 0
  }

 set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR]
 set user_exe_file "${cam_post_dir}/mesbox.exe"
 if { [file exists $user_exe_file] } {
     exec $user_exe_file $mom_warning_info
     return 0
 }


  return 1
}


#==============================================================
proc _set_attribute { } {
#
#==============================================================
    if {[llength [info commands MOM_set_attribute_program] ]} {
      MOM_set_attribute_program
    }
    return 0
}


#==============================================================
proc pb_base_stub_mom_extended_dll { } {
#
#==============================================================
;#  global mom_logname
;#  set ls [ list "chudoyakoveb68" ]
;#  set fam [ string tolower $mom_logname ]
;#  set fl 0
;#  foreach fm $ls {
;#    set fm [ string tolower $fm ]
;#    if {[ string compare $fam $fm ]==0} { set fl 1 ; break ; }
;#  }
;#  if {$fl==0} { return 0 }

    # puts stdout "pb_base_stub_mom_extended_dll-> "

    global cam_post_dir
    if {![hiset cam_post_dir]} { set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR] ; }

    set x64 0

    #set user_is64 ${cam_post_dir}is64.exe
    #if { [file exists $user_is64] } {
    #  set x64 [ exec -- $user_is64 ]
    #}

    ;## UGII_BASE_DIR = C:\UGS\UG_NX4
    ;## UGII_LIB1     = C:\Temp
    ;## UGII_LIB2     = C:\UGS\UG_NX4\ugii
    ;## UGII_UTIL     = C:\UGS\UG_NX4\ugii
    ;## UGII_ROOT_DIR = C:\UGS\UG_NX4\ugii
    ;##

    set root_dir [MOM_ask_env_var UGII_ROOT_DIR] ;
    set user_is64 ${root_dir}ugtcl.dll
    if { [file exists $user_is64] } {
    	set sz [ file size $user_is64 ]
    	set sz [ expr double($sz) ]
     	# 616960  for 64bit
    	# 462848  for 32
    	if {$sz>600000.} { set x64 1 ; } else { set x64 0 ; }
    }
    # puts stdout "\t x64=$x64 ( $user_is64 )"
    MOM_log_message "Work with x64=$x64 version UniGraphics"

    set user_dll ${cam_post_dir}pb_base_stub_x321.dll
    if {$x64} {
      set user_dll ${cam_post_dir}pb_base_stub_x641.dll
    }
    # puts stdout "\t user_dll=$user_dll"

    if { [file exists $user_dll] } {
      catch { MOM_run_user_function $user_dll ufusr }
    }

    return 0
}


#=============================================================
proc InitInstance {  } {
#=============================================================

;#  if {[llength [info commands cpFile] ]} {
;#    catch { cpFile }
;#  }

  if {[llength [info commands init_tcl ] ]} {
     init_tcl
  }

  if {[llength [info commands run_ugwish_start] ]} {
     run_ugwish_start
  }

  if {[llength [info commands PB_CMD_MOM_string_toupper] ]} {
    PB_CMD_MOM_string_toupper
  }

;#  if {[llength [info commands CreateList] ]} {
;#    catch { CreateList }
;#  }

  if {[llength [info commands  pb_base_stub_mom_extended_dll ] ]} {
      pb_base_stub_mom_extended_dll
  }

  #    'mom_extended_dll'
  if {[llength [info commands  PB_CMD_check_output_file ] ]} {
      PB_CMD_check_output_file
  }

 return 0
}


#
#  Lib
#
#==============================================================
proc init_tcl { } {
#    Lib
#==============================================================
 global tcl_library
 if {![hiset tcl_library]} {
    set tcl_lib1 [ MOM_ask_env_var TCL_LIBRARY ]
    if {$tcl_lib1==""} {
    	if {[info exist env(TCL_LIBRARY)]} {
    	  set tcl_lib1 $env(TCL_LIBRARY)
    	  set str ""
    	  if {[ regsub -all -nocase -- {(\\)+} $tcl_lib1 "/" str ]} {
    	   set tcl_lib1 $str
    	  }
    	}
    }
    set tcl_library $tcl_lib1
 }
 MOM_log_message "tcl_library = $tcl_library "

 global auto_path
 if {![info exists auto_path]} {
    if {[info exist env(TCLLIBPATH)]} {
     set auto_path $env(TCLLIBPATH)
    } else {
     set auto_path ""
    }
 }
 if {$auto_path==""} {
  	lappend auto_path $tcl_library
  	set tcl_lib2 [ MOM_ask_env_var TCLLIBPATH ]
  	if {$tcl_lib2!=""} {
  		lappend auto_path $tcl_lib2
  	}
 }
if {[string compare [info library] {}]} {
 foreach __dir [list [info library] [file dirname [info library]]] {
  if {[lsearch -exact $auto_path $__dir] < 0} {
     lappend auto_path $__dir
  }
 }
}

global tcl_pkgPath
if {[info exist tcl_pkgPath]} {
 foreach __dir $tcl_pkgPath {
   if {[lsearch -exact $auto_path $__dir] < 0} {
     lappend auto_path $__dir
	 }
 }
 MOM_log_message "tcl_pkgPath = $tcl_pkgPath"
}

 set str {}
 if {[ regsub -all -nocase -- {(\\)+} $auto_path "/" str ]} {
    set auto_path $str
 }

 MOM_log_message "auto_path = $auto_path"

#C:/TCL/lib/tcl8.2 C:/TCL/lib C:/UGS/UG_NX4/MACH/lib C:/TCL/lib/tk8.2

 set rt [ info library ]
 MOM_log_message "info library = $rt "

 set rf [ package names  ]
 MOM_log_message "package names = $rf"

 return 0
}


#=============================================================
proc run_ugwish_start { } {
#=============================================================
  global env

  set cam_post_dir [ MOM_ask_env_var UGII_CAM_POST_DIR ]
  set cam_aux_dir  [ MOM_ask_env_var UGII_CAM_AUXILIARY_DIR ]
  
  set file_run  ${cam_post_dir}pb_command.tcl

  global tcl_platform

  if [string match "*windows*" $tcl_platform(platform)] {
     set ug_wish "ugwish.exe"
  } else {
     set ug_wish ugwish
  }

  set file_exe  ${cam_aux_dir}$ug_wish

  if { [file exists $file_exe ] && [file exists $file_run ] } {
     exec $file_exe $file_run
  }
}


#
#
#
#==============================================================
proc CreateList { } {
#   -     -  
#==============================================================
  global mom_logname mom_date mom_ug_version mom_part_name
  global mom_event_handler_file_name mom_definition_file_name

  set ls [ list  "kondratenkoei68"  "zelepukhinma68" ]
  set fam [ string tolower $mom_logname ]
  set fl 0
  foreach fm $ls {
    set fm [ string tolower $fm ]
    if {[ string compare $fam $fm ]==0} { set fl 1 ; break ; }
  }
  if {$fl==0} {
    set fn "postlist.txt"
    if {![file exists $fn]} { return 0 ; }
    set rf [ open $fn a+ ]
    set path [ file tail $mom_definition_file_name ]
    puts $rf " logname=$mom_logname  || date=($mom_date) ug_version=($mom_ug_version) mom_part_name=$mom_part_name || mom_event_handler_file_name=$path "
    flush $rf
    close $rf
  }

  return 0
}


#
#
#
#==============================================================
proc _debug_check_user { advance_user } {
#         
#==============================================================
  global mom_logname mom_date mom_ug_version mom_part_name
  global mom_event_handler_file_name mom_definition_file_name
  global mom_warning_info

  set ls [ list "kondratenkoei68" "razinev68" "zelepukhinma68" "RogozinaSI68" "FedorovaTY68" "rodionovaea"]
  set fl 0
  set sysuser [ string tolower $mom_logname ]
  foreach fm $ls {
    set user [ string tolower $fm ]
    if {[ string compare $user $sysuser ]==0} { set fl 1 ; break ; }
  }
  if {$fl==0} {
      set mom_warning_info "\n\n\t  $mom_logname \n\n\t    -      !... \n\n"
      MOM_output_to_listing_device $mom_warning_info
      #MOM_catch_warning
      MOM_abort "$mom_warning_info"
  }

  return 0
}



########################
# Redefine MOM_abort
########################
if [llength [info commands _MOM_abort] ] {
   rename _MOM_abort ""
}

if [llength [info commands MOM_abort] ] {
   rename MOM_abort _MOM_abort
} else {
   proc _MOM_abort { message } { MOM_log_message $message  }
}


#=============================================================
proc MOM_abort { message } {
#=============================================================
#   MOM_abort  - () catch {...} ,
#     .
#
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  global warn_file list_file
  global group_warn_file group_list_file
  global warning_file_name
  global warn_count
  if {[hiset list_file]} {close $list_file ; unset list_file}
  if {[hiset warn_file]} {close $warn_file ; unset warn_file}
#  if {[file exists $warning_file_name]} {
#       catch { MOM_remove_file $warning_file_name }
#  }
  if {[hiset group_list_file]} {close $group_list_file ; unset group_list_file}
  if {[hiset group_warn_file]} {close $group_warn_file ; unset group_warn_file}
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  global msg_abort
  set msg_abort $message

  if {[llength [info commands MOM_abort_ex ] ]} {
   uplevel #0 {
      MOM_abort_ex $msg_abort
   }
  } else {
    set cam_aux_dir  [MOM_ask_env_var UGII_CAM_AUXILIARY_DIR]
    set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR]

    set user_exe_file "${cam_post_dir}/mesbox_abort.exe"
    if { [file exists $user_exe_file] } {
         exec  $user_exe_file  $msg_abort
    } else {

        global tcl_platform

        if [string match "*windows*" $tcl_platform(platform)] {
           set ug_wish "ugwish.exe"
        } else {
           set ug_wish ugwish
        }

        set pp_mes_file "${cam_post_dir}/pp_mes.ui.tcl"

        if { [file exists ${cam_aux_dir}$ug_wish] && [file exists $pp_mes_file] } {
            exec ${cam_aux_dir}$ug_wish $pp_mes_file $msg_abort
        }

    }
  }

  ;# _MOM_abort $message
  error "" "" "USER_ABORT"

  return 0
}

################################################################################

#  user_defined
#***************************
# Source in pb_ude tcl file.
#***************************
 set user_tcl_file ${cam_post_dir}pb_ude.tcl
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }

#    
#***************************
# Source in * tcl file.
#***************************
 set user_tcl_file ${cam_post_dir}pb_time.tcl
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }

#   
#***************************
# Source in pb_slowdn tcl file.
#***************************
 set user_tcl_file ${cam_post_dir}pb_slowdn.tcl
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }

#   
#***************************
# Source in pb_mirror tcl file.
#***************************
 set user_tcl_file ${cam_post_dir}pb_mirror.tcl
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }

#***************************
#     
#***************************
 set user_tcl_file ${cam_post_dir}PERFLPLZ.tcl
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }

#***************************
#     
#***************************
 set user_tcl_file ${cam_post_dir}PERFLcnc1600.tcl
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }

#
#***************************
# Source in * tcl file.
#***************************
 set user_tcl_file ${cam_post_dir}pb_cpfile.tcl
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }
